import turtle
t = turtle.Turtle()
w = turtle.Screen()
w.tracer(0)
w.bgcolor("black")  # 设置背景颜色
t.shape("classic")
t.color("orange")
t.pensize(3)
def tree(height,branchlen,branchwidth,t):
    if height >= 5:
        t.pensize(branchwidth-1)
        t.forward(height)
        if branchlen >= 5:
            t.right(25)
            tree(height - 5, branchlen - 15, branchwidth - 2, t)
            t.left(50)
            tree(height - 5, branchlen - 15, branchwidth - 2, t)
            t.right(25)
            t.backward(height)
def star():          # 定义画实心的五角星
    t.color("orange")
    t.begin_fill()
    for i in range(5):
        t.forward(20)
        t.right(144)
    t.end_fill()
    t.fillcolor("orange")

colordisk = ['#ff751a','#ff8533','#ff944d','#ffa366','#ffb380','#ffc299','#ff9933','#ffa64d','#ffb366',
'#ffbf80','#ffcc99','#ffa31a','#ffad33','#ffb84d','#ffc266']     # 调色盘
def stamp(x,y,i):          # 定义一个将turtle的形状印在画纸上特定位置的函数，颜色可以从调色盘中选取
    t.up()
    t.goto(x,y)
    t.color(colordisk[i])
    t.stamp()

t.left(90)
t.up()
t.backward(200)
t.down()              # 调整树的位置
tree(50,50,10,t)
star()                # 在树梢挂一颗小星星
stamp(0, 0,0)
stamp(-30, -30,1)
stamp(-40, 40,2)
stamp(-80, 0,3)
stamp(-100,-100,4)
stamp(-150,100,5)
stamp(-200,120,6)
stamp(-120,20,7)
stamp(-130,-70,8)
stamp(-180,20,9)
stamp(-100,160,10)
stamp(200,-200,11)
stamp(140,-140,12)
stamp(240,-100,13)
stamp(150,150,14)     # stamp得到一些分散的小图形，模仿飘散的树叶
t.up()
t.goto(-160,200)
star()
t.hideturtle()
w.update()
w.exitonclick()
