# coding=utf-8
# 递归树:Trinity
# 请全屏观看

import turtle
import random

def tree(branchlen,art):
    if branchlen>5:
        art.color(color(branchlen))  # 分段上色
        art.pensize(branchlen / 5)  # 树枝粗细与长度成正比
        mode=random.randrange(1,4)
        rightangle = randangle(branchlen)
        leftangle = randangle(branchlen)  # 随机左右转角
        if mode==2:  # 随机分两叉或三叉或不分叉
            art.forward(branchlen)
            art.right(rightangle)
            tree(reduct(branchlen),art)
            art.left(leftangle+rightangle)
            tree(reduct(branchlen),art)
            art.right(leftangle)
            art.color(color(branchlen))
            art.pensize(branchlen/5)
            art.backward(branchlen)
        elif mode==3:
            art.forward(branchlen)
            art.right(rightangle)
            tree(reduct(branchlen), art)
            art.left(rightangle)
            tree(reduct(branchlen), art)
            art.left(leftangle)
            tree(reduct(branchlen), art)
            art.right(leftangle)
            art.color(color(branchlen))
            art.pensize(branchlen / 5)
            art.backward(branchlen)
        else:
            art.forward(branchlen)
            tree(reduct(branchlen), art)
            art.color(color(branchlen))
            art.pensize(branchlen / 5)
            art.backward(branchlen)


def color(branchlen):
    if branchlen>=20:
        return "gray"
    else:
        return "green"

def reduct(branchlen):
    if branchlen>=100:
        return branchlen/(1+random.randrange(25,75)/100)
    elif branchlen>=35:
        return branchlen-10-random.randrange(2,8)
    else:
        return branchlen-4-random.randrange(1,3)

def randangle(branchlen):
    if branchlen>=100:
        return random.randrange(10,20)
    else:
        return random.randrange(15,40)

iris=turtle.Turtle()
wnd=turtle.Screen()
iris.speed(10)
iris.left(90)
iris.up()
iris.backward(320)
iris.down()
tree(165,iris)
wnd.exitonclick()