# coding=utf-8
# 无规行走递归树:TurtleTree
# 请全屏观看

import turtle
import random
import math

colorlist=["red","orange","yellow","aqua","green","blue",\
           "indigo","purple","pink","brown","black","gray"]
def TurtleTree(turtles,size,pos):
    if turtles<1:
        return
    if size<5:
        return
    for i in range(turtles):
        go = turtle.Turtle()
        go.left(90)
        go.up()
        go.setposition(pos)
        go.down()
        go.shape("turtle")
        go.speed(100)
        go.color(colorlist[random.randrange(0,12)])
        go.fillcolor(colorlist[random.randrange(0,12)])
        for t in range(size):
            go.forward(1)
            go.pensize(size/20)
            go.left(random.randrange(0, 15))
            go.right(random.randrange(0, 15))  # 每一步转角随机，均值0
        curpos=go.position()
        TurtleTree(math.floor(turtles/2),math.floor(size/2),curpos)

w = turtle.Screen()
trunk=turtle.Turtle()
trunk.left(90)
trunk.color("brown")
trunk.pensize(20)
trunk.backward(320)
trunk.hideturtle()
TurtleTree(10,200,(0,0))
w.exitonclick()