# 计时实验，List索引取值

import timeit  # 导入timeit模块
import random  # 导入random模块
for i in range(1000000, 100000001, 1000000):  # 循环进行共100次计时实验
    m = timeit.Timer('x[random.randrange(i)]', 'from __main__ import random,i,x')  # 创建Timer对象，参数1为按照索引取值的语句，参数2为"安装语句"
    x = list(range(i))  # 生成列表
    t = m.timeit(number=100)  # 调用timeit方法，反复运行100次，计时完毕后返回以秒为单位的时间
    print('%.8f' % t)  # 输出索引号及相应的取值时间

# 实验结果可发现，List索引取值用时基本不随列表长度的变化而变化，为O(1)数量级
