import random
import timeit
def binarySearch1(alist,item):#该函数是无切片的二分查找
    first = 0
    last = len(alist)-1
    found = False

    while first<=last and not found:
        midpoint =int((first + last)/2) #根据二分查找的思想，先找出中间项
        if alist[midpoint] == item:
            found = True
            return found
        else:
            if item<alist[midpoint]:  #将原列表平分成前后两个列表分别查找
                readin = list()
                for i in range(midpoint):
                    readin.append(alist[i])
                return binarySearch1(readin,item)
            elif item>alist[midpoint]:
                readin = list()
                for i in range(midpoint+1,len(alist)):
                    readin.append(alist[i])
                return binarySearch1(readin,item)


def binarySearch2(alist,item):#该函数是有切片的二分查找
    first = 0
    last = len(alist)-1
    found = False

    while first<=last and not found:
        midpoint =int((first + last)/2)#根据二分查找的思想，先找出中间项
        if alist[midpoint] == item:
            found = True
            return found
        else:#将原列表切片成两个独立的列表分别查找
            if item<alist[midpoint]:
                return binarySearch2(alist[:midpoint],item)
            elif item>alist[midpoint]:
                return binarySearch2(alist[midpoint+1:],item)
x = list()
y = 0
for i in range(1000000): #自动生成一个百万级别的列表，用于之后的性能测试
    y = random.randrange(1,10)+y
    x.append(y)

for j in range(100,1000000,2):
    t1 = timeit.Timer("binarySearch1(x,j)","from __main__ import binarySearch1,x,j")
    t2 = timeit.Timer("binarySearch2(x,j)", "from __main__ import binarySearch2,x,j")
    time1 = t1.timeit(number = 100)
    time2 = t2.timeit(number=100)
    print("%15.5f,%15.5f"%(time1,time2))
    print(binarySearch1(x,j))
    print(binarySearch2(x, j))