from pythonds.basic.stack import Stack
import re
import sys
myhtml= sys.stdin.read()
def htmlChecker(html):
    tagStack=Stack()#tagStack是专门用于存储前标签的栈
    Judge=True#判断前后标签的内容是否对应一致
    m=re.compile('<[^>,^<]*>')#通过正则表达式，找出所有的前标签和后标签
    allTags=m.findall(html)
    for index,tag in enumerate(allTags):
        tagName=getTagName(tag)
        if tagName[0]!="/":#将每一个tagName作为一个字符串来处理，如果是前标签，压入标签栈
            tagStack.push(tagName)
        else:#如果是闭合标签，将其标签名与标签栈栈顶元素比较，如果相等说明两者匹配，弹出前标签
            if tagStack.peek()==getCloseTagName(tagName):
                tagStack.pop()
            else:#如果不相同则说明闭合标签没有按要求匹配
                Judge= False
    if Judge and tagStack.isEmpty():#html标签正确的要求是，前后标签对应一致，且每一个前标签都有后标签与之相对
        return True
    else:
        return False

def getCloseTagName(closeTagName):
    return closeTagName[1:len(closeTagName)]

def getTagName(tag):#这是一个负责读入标签名的方法
    return tag[1:len(tag)-1].split(' ')[0]

print(htmlChecker(input()))
