def get_copy_del_chars(src, des):
    start = 0
    result = []
    for char in src:#遍历源单词字符串中的每个字母char#
        pos = des[start:].find(char)#在目的字符串中，从位置start开始找到字母char所在的位置#
        if pos >= 0:#如果char在目的字符串中存在#
            result.append(('copy', char))#向result列表添加一项（'char',char)
            start = start + pos + 1#目的字符串的查询起始位置向后延伸#
        else:
            result.append(('delect', char))#若char未在目标字符串中出现，则向result列表添加一项（'delect',char)
    return result#返回result列表#
def word2word(src, des):
    copy_del_chars = get_copy_del_chars(src, des)#get_copy_del_chars函数的返回结果：列表result 赋予copy_del_chars#
    result = []
    idx = 0
    for action, char in copy_del_chars:#遍历列表的action 和 char#
        if action == 'delect':
            result.append((action, char))#若action为delect，添加到result列表#
            continue
        if des[idx] == char:#若目标字符串中出现char#
            result.append((action, char)) #将（action，char）添加到result列表#
            idx += 1 #idx加1#
            continue
        while True:
            result.append(('insert', des[idx]))#若des中的字母src中没有出现，将insert和目标字符串中的字母添加到result列表#
            idx += 1#idx加1#
            if des[idx] == char:#若添加之后目标字符串中出现char#
                result.append((action, char))#将（ation，char）添加到result列表#
                idx += 1#idx加1#
                break #退出while循环#
    return result #返回result列表#
def calc_score(operates):
    score_map = {'insert': 20, 'copy': 5, 'delect': 20}#给定操作分数表#
    return sum(score_map[op[0]] for op in operates)#计算总共需要的分数#
if __name__ == '__main__':
    operates = word2word('algorithm', 'alligator')#向operates传入参数并执行word2word函数#
    print(calc_score(operates))