from pythonds.basic.queue import Queue
import random

def flowerdrum(namelist):   #定义击鼓传花函数
    simqueue = Queue()  #创建一个队列以存储人名
    s = ""  #创建字符串以存储输出字符串
    for name in namelist:   #遍历姓名表中的姓名，并以此进入队列
        simqueue.enqueue(name)
    while simqueue.size() > 1:  #当剩余人数大于1人时，继续游戏
        num = random.randint(1, 10000)  #num为1到10000中的随机数，表示每次击鼓传花的次数
        s += "num = %d " % (num, )  #记录每次击鼓传花的具体传递次数
        for i in range(num):    #将“花”传递num次，队首的人把“花”传给下一任并进入队尾
            simqueue.enqueue(simqueue.dequeue())
        s += "%s out\n" % (simqueue.dequeue())  #记录每一次击鼓传花出局的人
    s += "%s win" % (simqueue.dequeue())    #最后剩下的人为获胜者，并记录
    return s

print(flowerdrum(["Irving", "J.R.Smith", "Jones", "James", "Love", "TT", "Fyre", "D.Williams"]))