import timeit
import random

for i in range(10000, 1000001, 10000):
    gett = timeit.Timer("myd.get(random.randrange(%d))" % i, "from __main__ import random,myd")
    sett = timeit.Timer("myd[random.randrange(%d)]=1" % i, "from __main__ import random,myd")
    myd = {j: None for j in range(i)}
    get_time = gett.timeit(number=1000)
    set_time = sett.timeit(number=1000)
    print("%10.5f %10.5f" % (get_time, set_time))