from pythonds.basic.stack import Stack
def doMath(op,op1,op2):
    if op == "*":
        return op1*op2
    elif op == "/":
        return op1/op2
    elif op == "+":
        return op1+op2
    elif op == "-":
        return op1-op2
def function(lst):
    numberstack = Stack()
    signstack = Stack()
    prec = {}
    prec["^"] = 4
    prec["*"] = 3
    prec["/"] = 3
    prec["+"] = 2
    prec["-"] = 2
    prec["("] = 1
    # 分别把数字和字符压入栈中，同时清理掉所有括号，即先运算括号里面的内容
    for token in lst:
        if token in "0123456789":
            numberstack.push(token)
        elif token == "(":
            signstack.push(token)
        elif token == ")":
            while True:
                op = signstack.pop()
                if op == "(":
                    break
                else:
                    op2 = int(numberstack.pop())
                    op1 = int(numberstack.pop())
                    numberstack.push(doMath(op, op1, op2))
        else:
            while (not signstack.isEmpty()) and (prec[token] <= prec[signstack.peek()]):#这里和课件的大于等于是不一样的，但目的都是是要保证高一级运算先算的，且必须是小于等于
                op = signstack.pop()
                op2 = int(numberstack.pop())
                op1 = int(numberstack.pop())
                numberstack.push(doMath(op, op1, op2))
            signstack.push(token)
    #计算括号运算后剩下的部分
    while not signstack.isEmpty():
        op = signstack.pop()
        op2 = int(numberstack.pop())
        op1 = int(numberstack.pop())
        numberstack.push(doMath(op, op1, op2))
    return numberstack.pop()

print(function(input().split()))
#还是大佬一语中的，最开始的时候困惑于课件和这里的微小差距。还是上课没学透。还是要学习一个的
#输入按照计蒜客来了，需要加上空格