def backimage(l,t):  #画背景用的函数，常数是长度和龟
    t.goto(-l/2, -l/2)  #以圆心为中点画四边形
    t.begin_fill()
    for i in range(4):
        t.forward(l)
        t.left(90)
    t.end_fill()
    t.goto(0,-l/1.5)  #以圆心为中点画圆形
    t.fillcolor("#ccccb2")
    t.begin_fill()
    t.circle(l/3)
    t.end_fill()

def starflower(t):  #树上的星星
    if random.randint(0,3) == 1:  #控制星星数量
        t.pencolor("#ffecec")  #粉白
        t.fillcolor("#ffecec")
        t.begin_fill()
        for i in range(5):   #调颜色，画星星
            t.forward(10)
            t.right(144)
        t.end_fill()
        t.pencolor("#a23400")  #换回树枝颜色
def tree(branchLen,t):
    t.pensize(branchLen/20)  #树枝粗细与树枝长度有关
    if branchLen < 50:  #控制星星位置
        starflower(t)
    if branchLen > 10:  #递归画树
        if branchLen>40:  #使树干短的较快
            l_len = random.randint(3, 8)
            r_len = random.randint(3, 8)
        else:
            l_len = random.randint(2, 8)
            r_len = random.randint(2, 8)
        r_angle = random.randint(22, 30)
        l_angle = random.randint(20, 25)
        t.forward(branchLen)
        t.right(r_angle)
        tree(branchLen-r_len,t)
        t.left(r_angle + l_angle)
        tree(branchLen-l_len,t)
        t.right(l_angle)
        t.up()
        t.backward(branchLen)
        t.down()
import turtle
import random
t = turtle.Turtle()
w = turtle.Screen()
w.tracer(0)
backimage(700,t)  #画背景
t.up()
t.goto(0, -100)
t.down()
t.left(90)  #调位置
t.pencolor("#a23400")
tree(60,t)  #画树
t.left(30)
t.circle(200,35)  #假装是影子
t.up()
t.goto(-100,-100)
t.write("繁星照，",font = '微软雅黑')  #强行文艺
w.update()
w.exitonclick()
