import random
import timeit
def binarySearch1(alist,start,stop,item):
    if start>stop:
        return False
    else:
        midpoint = (start+stop)//2
    if alist[midpoint] == item:
        return True
    else:
        if item < alist[midpoint]:
            return binarySearch1(alist,start,midpoint-1,item)
        else:
            return binarySearch1(alist,midpoint+1,stop,item)

def binarySearch2(alist, item):
    if len(alist) == 0 :
        return False
    else:
        midpoint = len(alist)//2
    if alist[midpoint] == item:
        return True
    else:
        if item < alist[midpoint]:
            return binarySearch2(alist[:midpoint],item)
        else:
            return binarySearch2(alist[midpoint+1:],item)

x = random.randint(1000000,9000000)
testlist=[i for i in range(x)]
l=len(testlist)-1
testvalue=random.choice(range(x))
t1 = timeit.Timer("binarySearch1(testlist,0,l,testvalue)", "from __main__ import binarySearch1,testlist,l,testvalue")
print("搜索值为：%d 非切片所用时长为：%f seconds" % (testvalue, t1.timeit(100)))
t2 = timeit.Timer("binarySearch2(testlist,testvalue)", "from __main__ import binarySearch2,testlist,testvalue")
print("搜索值为：%d 切片所用时长为：%f seconds" % (testvalue, t2.timeit(100)))

