class HashTable:
    def __init__(self):
        self.size = 11
        self.slots = [None] * self.size
        self.data = [None] * self.size
        self.aslots = list()
        self.adata = list()
        self.num = 0
    def hashfunction(self,key):
        return key%self.size
    def rehash(self,oldhash):
       return (oldhash + 1)%self.size
    def put(self,key,data):
      if len(self.slots)/self.size > 0.9:#此处控制阈值，可更改
        self.aslots.append(self.slots)
        self.adata.append(self.data)
        self.num = self.num + 1
        self.slots = [None] * self.size
        self.data = [None] * self.size#将散列表的内容转移到另一个列表里
        #我对散列表的大小增长这一点感到很奇怪……是指能够储存的内容增长还是多增加几个槽？
        #鉴于增加槽的操作可能会造成错误，就选择了这种方式
      hashvalue = self.hashfunction(key)
      if self.slots[hashvalue] == None:
         self.slots[hashvalue] = key
         self.data[hashvalue] = data
      else:
         if self.slots[hashvalue] == key:
            self.data[hashvalue] = data
         else:
            nextslot = self.rehash(hashvalue)
            while self.slots[nextslot] != None and self.slots[nextslot] != key:
               nextslot = self.rehash(nextslot)
            if self.slots[nextslot] == None:
               self.slots[nextslot] = key
               self.data[nextslot] = data
            else:
               self.data[nextslot] = data
    def get(self,key):
        startslot = self.hashfunction(key)
        data = None
        stop = False
        found = False
        position = startslot
        if self.num == 0:#阈值尚未扩大
           while self.slots[position] != None and not found and not stop:
               if self.slots[position] == key:
                   found = True
                   data = self.data[position]
               else:
                   position = self.rehash(position)
                   if position == startslot:
                       stop = True
        else:#阈值已扩大
            while self.slots[position] != None and not found and not stop:#查找现在的散列表
               if self.slots[position] == key:
                   found = True
                   data = self.data[position]
               else:
                   position = self.rehash(position)
                   if position == startslot:
                       stop = True
            i=0#查找存储列表
            position = startslot
            while i <= len(self.aslots):
               while self.aslots[i][position] != None and not found and not stop:
                  if self.aslots[i][position] == key:
                      found = True
                      data = self.adata[i][position]
                  else:
                      position = self.rehash(position)
                      if position == startslot:
                          stop = True
               i = i + 1
        if data != None:
             return data
        else:
             raise IndexError("key is not in the map")
    def __getitem__(self,key):
       return self.get(key)
    def __setitem__(self,key,data):
       return self.put(key,data)
