import turtle
import random
#导入模块
t= turtle.Turtle() #生成一只海龟
w= turtle.Screen()

t.penup()
t.left(90)
t.forward(200)
t.left(90)
t.forward(200)
t.right(180)
t.pendown()
#画笔初始位置在左上角，初始方向向右

def hilbertCurve(n,t,len):
    if n == 1: #1阶希尔伯特曲线 形如]
        t.forward(len)
        t.right(90)
        t.forward(len)
        t.right(90)
        t.forward(len) #画出三条边
        t.right(90)
        t.penup()
        t.forward(len)
        t.pendown()
        t.right(90)#画笔返回初始位置，初始方向
    else:#第n阶曲线由四部分组成，每部分形状都和第n-1阶曲线相同，相邻两部分之间为一条衔接线
        #由于第一部分、第四部分是第n-1阶图形的旋转结果，需要先挪动画笔位置，而二、三阶只是第n-1阶图形的复制
        t.penup()
        t.forward((2**(n-1)-1)*len)#画笔挪到第一部分开始处
        t.pendown()
        t.right(90)
        hilbertCurve(n-1,t,len) #第一部分
        t.left(90) #画笔→
        t.forward(len) #画第一条衔接线
        hilbertCurve(n-1,t,len) #第二部分
        t.right(90) #画笔↓
        t.penup()
        t.forward((2**(n-1)-1)*len)
        t.pendown() #画笔挪到第二条衔接线处
        t.forward(len) #画衔接线
        t.left(90) #画笔→
        hilbertCurve(n-1,t,len) #第三部分
        t.right(90)#画笔↓
        t.penup()
        t.forward((2**(n-1)-1) * len)
        t.pendown() #画笔挪到第三条衔接线处
        t.right(90)#画笔←
        t.forward(len)#画衔接线
        t.penup()
        t.forward((2**(n-1)-1) * len)
        t.right(90)#画笔↑
        t.pendown()#画笔挪到第四部分开始处
        hilbertCurve(n-1, t,len)#第四部分
        t.penup()
        t.forward((2**n - 1) * len)
        t.right(90)
        t.pendown()
        # 画笔返回画本阶图形前的初始位置，初始方向

print("请输入希尔伯特曲线阶数。")
w.tracer(0)
#演示
n = int(input()) #n阶Hilbert曲线
len = 10
hilbertCurve(n,t,len)
w.exitonclick()

