import turtle #导入模块
import random
t= turtle.Turtle() #生成一只海龟
w= turtle.Screen() #获取屏幕对象，用于最后的点击自动关闭窗口

def tree(branchlen,t):
    t.pensize(1.04 ** branchlen)                        #海龟的宽度和树枝长度相关
    t.color((60+branchlen)/255 ,(190-branchlen*2)/255,(30+branchlen/3)/255)         #颜色与树枝长度有关
    angle = random.randrange(15,35)                                                 #转过角度为一个15到35的随机值
    randomlen = random.randrange(-1+int(-branchlen/10),1+int(branchlen/10))         #树枝的长度有一个随机变化的范围，树枝越长，变化的范围越大
    if branchlen > 5:
        t.forward(branchlen)                                #先画树干
        t.right(angle)                                      #右转画树
        tree(branchlen-7+randomlen,t)                       #画一个树枝变短的树
        t.left(2*angle)                                     #转到左边画树
        tree(branchlen-6+randomlen,t)
        t.right(angle)                                      #转正
        t.up()                                              #抬起画笔回到起点
        t.backward(branchlen)
        t.down()
    else:                                                   #达到末端时画一个点，象征一朵花
        t.dot(5,"violet")

turtle.tracer(0)                                            #暴走乌龟

t.left(90)
t.up()
t.backward(200)                                              #左转90度后退200，方便观察
t.down()
tree(75,t)                                                   #画树

turtle.update()
w.exitonclick() #作图完毕，欣赏结束后可以点击关闭窗口
