import turtle
t = turtle.Turtle()
Win = turtle.Screen()

def draw(t, n, i, j, len):
    if n == 1: #如果是一阶，则不需要递归直接画出
        if i == 1:  # 如果从左上角开始
            if j == 2:  # 从右上角出
                t.setheading(270)
                t.forward(len)
                t.setheading(0)
                t.forward(len)
                t.setheading(90)
                t.forward(len)
            else:  # 从左下角出
                t.setheading(0)
                t.forward(len)
                t.setheading(270)
                t.forward(len)
                t.setheading(180)
                t.forward(len)
        elif i == 4:  # 如果是从右下角进
            if j == 2:  # 从右上角出
                t.setheading(180)
                t.forward(len)
                t.setheading(90)
                t.forward(len)
                t.setheading(0)
                t.forward(len)
            else:  # 从左下角出
                t.setheading(90)
                t.forward(len)
                t.setheading(180)
                t.forward(len)
                t.setheading(270)
                t.forward(len)
    else:
        if i == 1: #如果从左上角开始
            if j == 2: #从右上角出
                draw(t, n-1, 1, 3, len)
                t.setheading(270)
                t.forward(len)
                draw(t, n-1, 1, 2, len)
                t.setheading(0)
                t.forward(len)
                draw(t, n-1, 1, 2, len)
                t.setheading(90)
                t.forward(len)
                draw(t, n-1, 4, 2, len)
            else: #从左下角出
                draw(t, n - 1, 1, 2, len)
                t.setheading(0)
                t.forward(len)
                draw(t, n - 1, 1, 3, len)
                t.setheading(270)
                t.forward(len)
                draw(t, n - 1, 1, 3, len)
                t.setheading(180)
                t.forward(len)
                draw(t, n - 1, 4, 3, len)
        elif i == 4: #如果是从右下角进
            if j == 2: #从右上角出
                draw(t, n - 1, 4, 3, len)
                t.setheading(180)
                t.forward(len)
                draw(t, n - 1, 4, 2, len)
                t.setheading(90)
                t.forward(len)
                draw(t, n - 1, 4, 2, len)
                t.setheading(0)
                t.forward(len)
                draw(t, n - 1, 1, 2, len)
            else: #从左下角出
                draw(t, n - 1, 4, 2, len)
                t.setheading(90)
                t.forward(len)
                draw(t, n - 1, 4, 3, len)
                t.setheading(180)
                t.forward(len)
                draw(t, n - 1, 4, 3, len)
                t.setheading(270)
                t.forward(len)
                draw(t, n - 1, 1, 3, len)

Win.tracer(0)
n = int(input()) #输入曲线的阶数
len = 800/(2 ** n) #确定线条长度

t.penup()
t.goto(-350, 350)
t.pendown() #到画面左上角再开始

draw(t, n, 1, 2, len)
Win.update()
Win.exitonclick()