import turtle
from random import *
t = turtle.Turtle()
w = turtle.Screen()
w.colormode(255)
w.screensize(2000,1500)
# w.bgpic(r"E:\净土\学习资料\python代码\各种作画\bg10.png")
# 配合背景图片可以获得更好的视觉效果
w.tracer(0) # 设置成暴走乌龟
def drawCurve(initial_pensize,branch):
    #这是画树枝的函数
    #initial_pensize：衡量树枝宽度
    #branch：衡量树枝长度
    node_list = [] # 用于保存需要分叉的节点，方便调用
    i = 0
    color_list = [(213,26,33),(254,67,101),(252,157,154),(249,205,173),
                  (200,200,169),(131,175,155),(255,245,247)]
    # 挑选比较好看的颜色
    pensize = initial_pensize
    while pensize > 0:
    # 设定最小规模，绘制出渐细的树枝
    # 曲率一般都比较小，偶尔出现曲率较大的情形
        #接下来根据分段选择笔的颜色（直男癌配色方案）
        if pensize > 7:
            t.color(color_list[0])
        elif pensize > 6:
            t.color(color_list[1])
        elif pensize > 5:
            t.color(color_list[2])
        elif pensize > 4:
            t.color(color_list[3])
        elif pensize > 3:
            t.color(color_list[4])
        elif pensize > 2:
            t.color(color_list[5])
        elif pensize > 0:
            t.color(color_list[6])
        t.pensize(pensize)
        a = uniform(branch, branch*1.6)
        b = uniform(30, 60) * 0.8 + uniform(60, 330) * 0.2
        # 绘制曲线
        if i % 2 == 0:
            t.circle(a, b)
            pensize -= 1
        else:
            t.left(180)
            t.circle(a, -b)
            t.left(180)
            pensize -= 1
        i += 1
        # 每个节点都有66.7%的概率被记录，这些节点上会生成新的树枝
        if randint(1,3) % 3 != 0 and pensize > 0:
            node_list.append((t.position(),t.heading(),pensize))
        # 在树枝的末端添加树叶
        if pensize < 3:
            drawHeart(branch/5)
    # node_list里的每个元素都一个元组，元组中的元素分别是节点的坐标、海龟朝向和笔的粗细
    return node_list
def drawHeart(size=111.65):
    # 这是画心形树叶的函数，树叶大小由size决定
    head = t.heading()
    t.color('pink')
    t.begin_fill()
    t.left(140+180)
    t.forward(size)
    t.circle(size/1.95,200)
    t.left(240)
    t.circle(size/1.95,200)
    t.forward(size)
    t.end_fill()
    t.seth(head)
    # 画完树叶后恢复海龟的朝向
def tree(initial_pensize,branch):
    # 这是画分形树的函数
    if initial_pensize > 0 and branch > 5:
        node_list = drawCurve(initial_pensize,branch)
        while len(node_list) > 0:
            # 在记录的节点上调用tree函数
            # 各种处理，总之为了结果好看一点。。。
            temp = node_list.pop()
            t.up()
            t.setpos(temp[0])
            t.down()
            if temp[1]<180 and temp[1]>0:
                if randint(1,2)%2:
                    t.seth(temp[1]-40)
                else:
                    t.seth(temp[1]+40)
            else:
                t.seth(randint(40,140))
            tree(temp[2],branch/1.618)
xcor = 0
# 嗯这里可以画一棵树也可以画一片树林
for x in range(1):
    t.up()
    t.goto(xcor,-300)
    t.down()
    t.seth(40)
    # 调整一下树根的位置，准备作画
    tree(8,50)
    xcor += randint(100,300)
w.update()
w.exitonclick()
