from timeit import Timer
import random

def getitem():#定义字典get item语句，从字典中随机取值
    mydict[random.randrange(0,10**n)]

def setitem():#定义字典set item语句，给字典中随机key赋值
    mydict[random.randrange(0,10**n)] = None

for n in range(8):#字典数据规模从一到一千万
    mydict = {x:x for x in range(10**n)}#生成字典
    t1 = Timer("getitem()","from __main__ import getitem")#记录执行get item1000遍的时间并输出
    t2 = Timer("setitem()","from __main__ import setitem")#记录执行set item1000遍的时间并输出
    print("n = %9.d, t1 = %f, t2 = %f\n" %(10**n,t1.timeit(number = 1000),t2.timeit(number = 1000)))