from timeit import Timer
import random

def dellist():#定义列表del语句
     del mylist[random.randrange(0,2**n)]

def deldict():#定义字典del语句
     del mydict[random.randrange(0,2**n)]

for n in range(18,26):#列表和字典的数据规模从2^18到2^25
    mylist = [x for x in range(2**n)]#生成列表和字典
    mydict = {x:None for x in range(2**n)}
    t1 = Timer("dellist()","from __main__ import dellist")##记录执行del100遍(硬件所限)的时间并输出
    t2 = Timer("deldict()","from __main__ import deldict")
    print("n = %10.d, t1 = %f, t2 = %f" %(2**n,t1.timeit(number = 100),t2.timeit(number =  100)))