from l5_1 import Node
from l5_1 import unorderedlist
class orderedlist(unorderedlist):
    append = None#append和insert已经没有存在的必要，因此删去这两个方法
    insert = None
    def add(self,item):#将某元素加入到有序表中
        current = self.head
        previous = None#设置变量存前一个节点
        stop = False#设置变量来决定是否停止
        while current!=None and not stop:
            if current.getData()>item:
                stop = True#一旦找到比加入元素大的元素就暂停
            else:
                previous = current
                current = current.getNext()
        temp  = Node(item)
        if previous==None:#在第一个节点插入的情况拿出来讨论
            temp.setNext(self.head)
            self.head = temp
        else:#其他情况分作一类讨论
            temp.setNext(current)
            previous.setNext(temp)
        self.lsize+=1
    def search(self,item):#寻找是否存在某元素
        current  = self.head
        while current.getNext()!=None:
            if current.getData()==item:
                return True
            elif current.getData()>item:#一旦找到比它大的就停止寻找
                return False
            else:
                current = current.getNext()
        if current.getData()!=item:#如果找到最后都没有，则不存在该元素
            return False

    def __getitem__(self, num):  # 找到对应位置的元素或者进行切片
        if isinstance(num, int):  # 首先如果输入的是int类型，就找到对应位置的数
            if num < 0:  # 首先将位置的数转换成正数
                num += self.lsize
            current = self.head
            i = 0  # 设计一个变量来找到对应位置
            while i < num:
                current = current.getNext()
                i += 1
            return current.getData()
        else:  # 如果是一个slice类型，则对它进行切片
            start = num.start
            stop = num.stop
            step = num.step
            if step == None:  # 首先对步数是正还是负进行讨论
                step = 1
            if step > 0:  # 如果步数为正则进行以下操作来规范数据
                if start == None:
                    start = 0
                elif start + self.lsize < 0:
                    start = 0
                elif start < 0:
                    start += self.lsize
                if stop == None:
                    stop = self.lsize
                elif stop + self.lsize < 0:
                    stop = 0
                elif stop > self.lsize:
                    stop = self.lsize
                elif stop < 0:
                    stop += self.lsize
            if step < 0:  # 如果步数为负则进行以下操作来规范数据，思路与正数相同，只是正负性恰好相反
                if start == None:
                    start = -1
                elif start - self.lsize >= 0:
                    start = -1
                elif start >= 0:
                    start -= self.lsize
                if stop == None:
                    stop = -1 - self.lsize
                elif stop - self.lsize >= 0:
                    stop = -1
                elif stop < -self.lsize:
                    stop = -1 - self.lsize
                elif stop >= 0:
                    stop -= self.lsize
            s = orderedlist()  # 设计一个新的无序表来存数据
            for x in range(start, stop, step):
                s.add(self[x])
            return s
        #注：search唯一的改变在于它所需要处理的平均步数会更少，因为可以在找到比它大的数时提前终止

# 以下是我用来检验是否正确时所采用的
a = orderedlist()
for i in range(0,10,2):
    a.add(i)
a.add(1)
print(a)
a.remove(6)
print(a)
b=a[1:5]
print(b)
b.add(5)
print(b)