from random import randrange
import turtle
#树的元素除了长度还加上宽度以便于调整
def tree(blen,t,width):
    colorlist = ['pink','red','orange','green','yellow']#树的颜色有这几种颜色中选择，原本我想用rgb方法随机数
    #但是没有调出自己想要的结果，所以只好用特定的颜色，个人比较倾向于暖色系看着舒服一些
    t.color(colorlist[randrange(5)])
    if blen>=20:
        t.pensize(width)#设定线宽
        t.forward(blen)
        if blen<=25:#在顶端的树枝加上小花
            t.fillcolor(colorlist[randrange(5)])
            t.begin_fill()#给小花涂上颜色
            t.right(120)
            t.circle(5, 240)
            t.right(120)
            t.circle(5, 240)
            t.right(120)
            t.circle(5, 240)
            t.end_fill()
        a = randrange(25, 45)#设定角度在一定范围内随机变化
        b = randrange(20, 30)
        c = randrange(20, 30)
        d = randrange(20,30)
        t.right(a)
        tree(blen-18,t,width*0.6)
        t.left(b)
        tree(blen-randrange(18,21),t,width*0.6)#对枝条长度的减小进行小范围的随机
        t.left(c)
        tree(blen-randrange(18,21),t,width*0.6)
        t.left(d)
        tree(blen-18,t,width*0.6)
        t.right(d+b + c - a)#为了保证最后海龟对准来时的方向，将四个方向事先得到进行这种处理
        t.backward(blen)

def main():
    t = turtle.Turtle()
    w = turtle.Screen()
    w.tracer(0)#运用暴走海龟
    t.left(90)
    t.up()
    t.backward(300)
    t.down()#让海龟到达比较靠下的一个点且不留下痕迹
    tree(150,t,30)
    t.color('brown')  # 树干我选择单独拿出来画，因为觉得太细了不是很好看
    t.pensize(30)
    t.forward(170)
    t.backward(125)
    t.pensize(35)#树干的宽度调整让它有一次渐变
    t.backward(75)
    t.pensize(29)#画完树干后加上地面
    t.right(90)
    t.forward(600)
    t.backward(1200)
    w.update()
    w.exitonclick()

main()