import turtle
import random
t=turtle.Turtle()
def drawapple(t):#画一个抽象的苹果
    t.color('red')
    t.pensize(6)
    t.circle(4)
def tree(branchLen,t):#画一棵树
    if branchLen>5:#枝长大于5是继续进行画枝

        t.pensize(branchLen*0.2)#枝的粗度是树枝的长度的0.2倍
        t.forward(branchLen)#画树枝
        p=random.randint(20,40)#生成两个随机数用于确定树枝角度
        q=random.randint(20,40)
        t.right(p)#向右转随机的角度
        if branchLen>50:#枝长大于50时，是树干，涂成棕色，下级枝长为原枝长的0.6到0.7（为了好看点，不然就更丑了。。。）
            t.color("brown")
            tree(branchLen*random.randint(6,7)*0.1,t)
        else:#小于50的枝长，下级枝长为原枝长的0.75到0.85
            if branchLen < 15:#枝长小于15，认为是叶子的部分，涂成绿色
                t.color("green")
                t.pensize(branchLen * 0.4)
            else:
                t.color('brown')#枝长在15到50之间，认为还是树枝，涂成棕色
                t.pensize(branchLen * 0.2)
            tree(branchLen*random.randint(75,85)*0.01,t)
        t.left(2*q)#向左转随机的角度，但期望是和右侧保持对称的
        if branchLen>50:#按照同样的方式区分树干，树枝和树叶
            t.color("brown")
            tree(branchLen*random.randint(6,7)*0.1,t)
        else:
            if branchLen < 15:
                t.color("green")
                t.pensize(branchLen * 0.4)
            else:
                t.color('brown')
                t.pensize(branchLen * 0.2)
            tree(branchLen*random.randint(75,85)*0.01,t)
        t.right(2*q-p)#方向回正
        t.penup()#抬笔并且回原位
        t.backward(branchLen)
        t.pendown()#落笔之后画苹果
        apple=random.randint(1,20)#生成随机数决定出不出现苹果
        if apple==10 and branchLen<25 and branchLen>8:#苹果只在靠近树叶的附近出现
            drawapple(t)

myWin=turtle.Screen()
myWin.tracer(0)
t.left(90)
t.up()
t.backward(100)
t.down()
t.color("brown")
tree(100,t)#画一个很丑的苹果树
myWin.update()
myWin.exitonclick()


