#利用链表实现栈和队列
from UOL import UnorderedList        #............导入无序表模块


class Stack:
    def __init__(self):
        self.init = UnorderedList()          #..........生成内部操作结构（无序表）
                                             # 相应方法用无序表模拟
    def isEmpty(self):
        return self.init.isEmpty()

    def size(self):
        return self.init.size()

    def push(self, item):          #......将item压入栈顶，相当于添加至表头
        self.init.add(item)

    def pop(self):                      #.........弹出栈顶，相当于弹出表头，故为pop(0)
        return self.init.pop(0)

    def peek(self):                        #..........返回栈顶数据，亦即表头数据
        return self.init.head.getData()


class Queue:
    def __init__(self):
        self.init = UnorderedList()                  #..........生成内部操作结构（无序表）
                                                     #........相应方法用无序表模拟
    def isEmpty(self):
        return self.init.isEmpty()

    def size(self):
        return self.init.size()
                                       #..................表头为队尾，表尾为队首
    def enqueue(self, item):                #...........从表头一侧入队（add）
        self.init.add(item)

    def dequeue(self):                      #...........从表尾一侧出队（pop()）
        return self.init.pop()
