import turtle
import random
turtle.tracer(0)
def tree(branchLen,t):
    t.speed(100)
    w=branchLen//10#使用地板除法设置树枝粗细，树枝变短的同时也会变细
    q=random.randint(20,45)#q为随机数，代表树枝倾斜的角度
    if branchLen>50:
        if w>1:#根据w的值具体确定树枝的粗细
            t.pensize(random.randint(w-1,w))
        else:
            t.pensize(random.randint(1,2))
        a=random.uniform(0.1,0.3)#a为0.1至0.3之间的随机小数，用来调整树干的颜色，大致为黑色
        t.forward(branchLen*1.5)
        t.right(q)
        tree(random.randint(branchLen-12,branchLen-10),t)#树干的长度在一个范围内随机变化
        t.color(a,a,a)
        t.left(2*q)
        tree(random.randint(branchLen-12,branchLen-10),t)
        t.color(a,a,a)
        t.right(q)
        t.backward(branchLen*1.5)
    
    elif branchLen>=1 and branchLen<=50:
        if w>1:
            t.pensize(random.randint(w-1,w))
        else:
            t.pensize(random.randint(1,2))
        b=random.uniform(0.9,1)#设置b、c、d三个参数作为三原色的值
        c=random.uniform(0.5,0.6)
        d=random.uniform(0.2,0.3)
        t.forward(branchLen)
        t.right(q)
        if branchLen<=2:
            t.color(b,c,d)#b,c,d用来调整花朵的颜色，大致为粉色、橙色
            t.begin_fill()
            for i in range(5):#当树枝非常小时，用画五边形的方法代表花朵，并填充颜色
                t.forward(2)
                t.right(72)
            t.end_fill()
        else:
            t.color("green")
        tree(random.randint(branchLen-7,branchLen-3),t)#树干的长度在一个范围内随机变化
        t.left(2*q)
        tree(random.randint(branchLen-7,branchLen-3),t)
        t.right(q)
        if branchLen<=2:
            t.color(b,c,d)
        else:
            t.color("green")
        t.backward(branchLen)
    
turtle.update()    
def main():
    t=turtle.Turtle()
    myWin=turtle.Screen()
    t.left(90)
    t.up()
    t.backward(300)
    t.down()
    tree(80,t)
    myWin.exitonclick()
main()

