import turtle
import random
turtle.tracer(0)
def tree(branchLen,t):
    w=branchLen//10#使用地板除法设置树枝粗细，树枝变短的同时也会变细
    if branchLen>=3:
        a=random.uniform(0,0.3)
        b=random.uniform(0.9,1)#设置b、c、d三个参数作为三原色的值
        c=random.uniform(0.5,0.6)
        d=random.uniform(0.2,0.3)
        if w>1:#根据w的值具体确定树枝的粗细
            t.pensize(w-1)
        else:
            t.pensize(2)
        if branchLen>40:
            t.color(a,c,b)
            t.forward(branchLen)
            t.right(20)
            tree(branchLen-10,t)
            t.left(40)
            tree(branchLen-10,t)
            t.right(20)
            t.color(a,c,b)
            t.backward(branchLen)
        elif branchLen>=3 and branchLen<=40:
            t.color(a,d,c)
            t.forward(branchLen)
            t.right(20)
            tree(branchLen-5,t)
            t.left(40)
            tree(branchLen-5,t)
            t.right(20)
            t.color(a,d,c)
            t.backward(branchLen)
        
turtle.update()    
def main():
    t=turtle.Turtle()
    myWin=turtle.Screen()
    t.left(90)
    t.up()
    t.backward(150)
    t.down()
    tree(80,t)
    myWin.exitonclick()
main()

