"""
def triangle(num):#num是打印杨辉三角的行数  
      triangle=[]  
      sublist=[]  
      for i in range(1,num+1):       
          sublist=sublist+[1]             
          for j in range(1,i-1):  
              sublist[-j-1]=sublist[-j-1]+sublist[-j-2]#从倒数第二个元素开始向前处理，直到正数第二个元素。  
          triangle.append(sublist)  
      return triangle
这段代码与下面的def triangle(num)能达到相同的效果。
"""
def triangle(num):#num是打印杨辉三角的行数   
    triangle=[[1]]  
    for i in range(2,num+1):  
        triangle.append([1]*i)  
        for j in range(1,i-1):  
            triangle[i-1][j]=triangle[i-2][j]+triangle[i-2][j-1]#递归  
    return triangle  
def pascalTriangle(triangle,width):  
    column=len(triangle[-1])*width#得到包括空格的一行最长打印长度  
    for sublist in triangle:  
        result=[]  
        for contents in sublist:  
            result.append('{0:^{1}}'.format(str(contents),width))#控制各行数字间距。str（contents）占据的总宽度为width，不足的在两边用空格补齐。这样做的结果是每一个加入result的数字两边都有空格。  
        print('{0:^{1}}'.format(''.join(result),column))#控制缩进。‘’.join（）占据总宽度为‘盒子’总宽度column（而column又由行数决定），并用空格在两边补齐空位。  
          
if __name__=='__main__':  
    num=int(input('num:'))  
    triangle=triangle(num)  
    width=len(str(triangle[-1][len(triangle[-1])//2]))+3#得到一行中最大数字的位数，然后为了使各个数值之间有一定的间隔，所以让宽度再加上3（3是通过试验得到的输出最符合可视化要求的添加宽度）  
    pascalTriangle(triangle,width)  
