import turtle                          #汉诺塔
from pythonds.basic.stack import Stack #栈的目的主要是计数，使盘片移动到相应高度
w = turtle.Screen()
t00 = turtle.Turtle()                  #首先把放盘子的架画出来
t00.speed(0)
t00.right(90)
t00.up()
t00.forward(100)
t00.down()
t00.left(90)
t00.forward(350)
t00.backward(175)
t00.left(90)
for i in range(3):                 
    t00.forward(200)
    t00.backward(200)
    t00.left(90)
    t00.forward(175)
    t00.right(90)                       #画完了
def huitu(a,b,c,d):                     #绘图的函数
    t = []                              #用列表存turtle
    for i in range(a):
        t += [turtle.Turtle()]          #加入turtle
        t[i].shape('square')            #设置turtle形状
        t[i].shapesize(2+i,0.5,20)      #形状设置完毕 
        t[i].speed(0)                   #准备阶段要尽快移动
        t[i].up()                       #让海龟飞起来 
        t[i].right(90)                  #运动到出发点
        t[i].forward(100)
        t[i].right(90)
        t[i].forward(175)
        t[i].right(90)
        t[i].forward(30*a-15-30*i)      #到地方了
        t[i].speed(3)                   #准备开始表演，所以要减速
    s = []
    for i in range(3):                  #栈存储的是某根架子上的盘片个数
        s += [Stack()]
        if i == 0:
            for j in range(a):
                s[0].push(j)
    hannuota(a,b,c,d,t,s)               #然后跑汉诺塔程序
def dong (fr,to,t,h,s):                 #这是运动的程序
    a = s[fr-1].pop()                   #拿出盘片时，栈的元素个数减少
    t.forward(290-30*s[fr-1].size())    #开始移动盘片
    if fr > to:                         #看一下要往哪移
        t.speed(0)                      #先转身，要以极快的速度完成，让人看不出来转过身了
        t.left(90)
        t.shapesize(0.5,1+h,20)         #这样改变形状就看不出来盘片的旋转了
        t.speed(3)                      #恢复原速
        t.forward(175*(fr-to))          #运动过去 
        t.speed(0)                      #再次转身
        t.shapesize(1+h,0.5,20)
        t.right(90)
        t.speed(3)                      #恢复原速
    else:                               #这半部分除了方向与前半部分相反之外没区别
        t.speed(0)
        t.right(90)
        t.shapesize(0.5,1+h,20)
        t.speed(3)
        t.forward(175*(to-fr))
        t.speed(0)
        t.shapesize(1+h,0.5,20)
        t.left(90)
        t.speed(3)
    t.backward(290-30*s[to-1].size())
    s[to-1].push(a)
def hannuota(h,fr,to,wi,t,s):            #汉诺塔函数基本是照课件抄的
    if h >= 1:
        hannuota(h-1,fr,wi,to,t,s)
        dong(fr,to,t[h-1],h,s)           #把输出改成了运动
        hannuota(h-1,wi,to,fr,t,s)
huitu(5,1,3,2)                           #绘图才是主体
w.exitonclick()
