#汉诺塔动画

import turtle

def main():
    n = int(input('请输入圆盘数: '))                          #n个盘子
    colorlist = ['yellow','pink','orange','violet','black','blue']
    turtlelist = [turtle.Turtle() for i in range(n)]        #n个乌龟作图
    myWin = turtle.Screen()
    for i in range(n):
        turtlelist[n-i-1].shape('square')                   #形状设为正方形
        turtlelist[n-i-1].shapesize((n-i),(n-i),20)         #大编号为大盘子，放在下面
        turtlelist[n-i-1].color(colorlist[i%6])
        turtlelist[n-i-1].up()
        turtlelist[n-i-1].goto(-200,0)                      #放于初始位置
    Hanoi(n,(-200,0),(200,0),(0,0),turtlelist)
    myWin.exitonclick()

def Hanoi(height,startpt,endpt,mediumpt,turtlelist):        #参数为：阶数、三根杆的坐标、盘子列表
    if height>=1 :
        Hanoi(height-1,startpt,mediumpt,endpt,turtlelist)
        move(endpt,turtlelist[height-1])                    #上面的盘子都移到中间杆后，最大的盘子移到终点
        Hanoi(height-1,mediumpt,endpt,startpt,turtlelist)

def move(endpt,myturtle):
    myturtle.goto(endpt[0],endpt[1])                        #将某一个盘子移动到指定位置

main()