# 分别读入初始字符串和目标字符串
source = str(input("请输入初始字符串\n"))
target = str(input("请输入目标字符串\n"))

# n和m记录两个字符的长度
n = len(source)
m = len(target)

# 定义距离step和得分cost
copycost = 5
delecost = 20
insecost = 20
copystep = 0
delestep = 1
insestep = 1

# 当初始字符串和目标字符串长度都增加1时，判断是做替换还是复制
def subscost(a, b):
    return [copycost, delecost + insecost][[True, False].index(a == b)]

def subsstep(a, b):
    return [copystep, delestep + insestep][[True, False].index(a == b)]

# 二维列表resultslist存每一步的结果，resultslist[i][j]是一个列表[a,[c]],其中a,c分别表示最小距离和步骤列表，先将每个位置初始为[0,[]]
resultslist = []
for t in range(0, n + 1):
    resultslist.append([])
for row in range(0, n + 1):
    for col in range(0, m + 1):
        resultslist[row].append([0, []])

# 将第零行和第零列数据初始化
for x in range(1, n + 1):
    resultslist[x][0][0] = resultslist[x - 1][0][0] + delestep
    resultslist[x][0][1] = resultslist[x - 1][0][1] + ["删除%s" % (source[x - 1])]

for y in range(1, m + 1):
    resultslist[0][y][0] = resultslist[0][y - 1][0] + insestep
    resultslist[0][y][1] = resultslist[0][y - 1][1] + ["插入%s" % (target[y - 1])]

for i in range(1, n+1):
    for j in range(1, m+1):
        # 最小步数是三种方式的最小值
        minstep = min(resultslist[i][j - 1][0] + insestep,
                resultslist[i - 1][j - 1][0] + subsstep(source[i - 1], target[j - 1]),
                resultslist[i - 1][j][0] + delestep)
        # 分三种情况来做递推
        if minstep == resultslist[i - 1][j - 1][0] + subsstep(source[i - 1], target[j - 1]):
            resultslist[i][j][0] = minstep
            if source[i - 1] == target[j - 1]:
                resultslist[i][j][1] = resultslist[i - 1][j - 1][1] + ["复制%s" % (source[i - 1])]
            else:
                resultslist[i][j][1] = resultslist[i - 1][j - 1][1] + ["删除%s，插入%s" % (source[i - 1], target[j - 1])]
        elif minstep == resultslist[i][j - 1][0] + insestep:
            resultslist[i][j][0] = minstep
            resultslist[i][j][1] = resultslist[i][j - 1][1] + ["插入%s" % (target[j - 1])]
        else:
            resultslist[i][j][0] = minstep
            resultslist[i][j][1] = resultslist[i - 1][j][1] + ["删除%s" % (source[i - 1])]

print('最小距离为', resultslist[n][m][0])
# 将最小距离换算成得分
print('最小得分为', (m + n - resultslist[n][m][0])//2*5 + resultslist[n][m][0]*20)
# 输出步骤
print('步骤为:\n', '\n'.join(resultslist[n][m][1]))
