def burglar(maxweight, treasure):
# 定义burglar函数，其参数是最大承重量和宝物列表
    temp_valueList = [[0 for j in range(len(treasure))] for i in range(maxweight+1)]
    taken_list = [[0 for j in range(len(treasure))] for i in range(maxweight+1)]
    # 建立两个二维列表，用来储存当前重量下宝物能取得的最大价值和取得宝物的列表
    for weight in range(len(temp_valueList)):
        for j in range(len(treasure)):
            # 分别遍历最大承重量和宝物列表
            choice = treasure[j]
            if weight == 0 or j == 0:
                temp_valueList[weight][j] = 0
                # 设置初值，当背包承重量为0，或者没有宝物开始循环的时候，最大价值为0
            else:
                if weight < choice['w']:
                    temp_valueList[weight][j] = temp_valueList[weight][j-1]
                    # 如果当前的宝物重量大于当前的承重量，那么最大价值等于前一个承重量对应的最大价值
                else:
                    if temp_valueList[weight-choice['w']][j-1] + choice['v']>temp_valueList[weight][j-1]:
                        # 动归的判定条件，如果当前的物品价值加上根据之前记录的当前重量减去当前物品的重量
                        # 大于当前重量的能获得的最大价值，而且这个物品还不在已经选取的物品列表里，那么进行如下操作
                        temp_valueList[weight][j] = temp_valueList[weight-choice['w']][j-1] + choice['v']
                        taken_list[weight][j] = 1
                    else:
                        # 否则，进行最大价值取较大的当前承重量对应的最大价值，其余操作相同
                        temp_valueList[weight][j] = temp_valueList[weight][j-1]
    pre_weight = maxweight
    j = len(treasure)-1
    print('The selected list is as follows:')
    while j>0 and pre_weight>0:
        if taken_list[pre_weight][j] == 1:
            print( 'treasure' + str(j) + ' value ' + str(treasure[j]['v']))
            pre_weight = pre_weight - treasure[j]['w']
        j = j-1
    return temp_valueList[maxweight][len(treasure)-1]
    # 通过最大承重量对储存选择的宝物的列表进行遍历，输出宝物的序号，以及对应的价值
alist = list()
alist.append(None)
n = int(input())
for i in range(n):
    newweight, newvalue = list(map(int, input().split()))
    newitemdict = {'w': newweight, 'v': newvalue}
    alist.append(newitemdict)
# 建立一个列表，用来录入输入的宝物个数和宝物的属性，并将其转化为字典格式储存在列表中
print('The maximun value the burglar can take is:%s'%(burglar(20, alist)))
# 输出能取得的最大价值