import turtle
import random
colors=['orange', 'green','black','purple','red', 'yellow', 'blue' ]#为每个层次分配的不同颜色
def drawleaf(t):#画出末端的叶子
        t.width(5)#通过加粗画笔表现出叶子的感觉
        t.pencolor('green')#叶子为绿色
        a=random.randint(4,12)#叶子有长有短
        t.forward(a)
        t.backward(a)
def drawfruit(t):
        t.width(10)
        t.pencolor('red')
        t.forward(7)
        t.backward(7)
def tree(branchlen,t):
    if branchlen>8:
        x=random.randint(1,branchlen/4)#一棵树的每个位置都可能长出叶子，且越向末端概率越大,之后这里不再继续长枝条
        if x==1 and branchlen!=96:     #因此设置随机量x来模拟这个情况，同时防止从根上直接长出一片叶子。。。。
            drawleaf(t)
        else:
            t.width(branchlen/16)#越向末端树枝越细
            t.pencolor(colors[int(branchlen/8)%7])#选取颜色
            a=random.randint(branchlen-8,branchlen+8)#树枝越向后越短，同时围绕标准值随机变化
            t.forward(a)
            delta=random.randint(15,40)#随机向右偏转
            t.right(delta)
            tree(branchlen-8,t)#引用下一层情况
            t.left(delta)#回归原位置
            gamma=random.randint(15,40)#随机向左偏转
            t.left(gamma)
            tree(branchlen-8,t)#引用下一层 
            t.right(gamma)#回归原位置
            t.width(branchlen/16)#重新设置画笔颜色和粗细
            t.pencolor(colors[int(branchlen/8)%7])
            t.backward(a)
    else:
        x=random.randint(1,20)
        if x==1:
                drawfruit(t)
        else:
                drawleaf(t)#当长度不能再小时，画叶子
t=turtle.Turtle()#新建画笔
t.hideturtle()
window=turtle.Screen()
t.screen.delay(0)#加快画笔速度
t.left(90)#调整画笔初始角度和位置
t.up()
t.backward(250)
t.down()
tree(88,t)#画树
turtle.done()#保持界面不自动关闭


