#用递归方法产生杨辉三角，按元素递归。输入阶（行）数，返回对称分布的三角
#20行以内耗时1秒左右以内，30行以上需要很长时间。明显慢于按行递归方式

#产生每个元素的递归函数：当元素在行的首末时返回1；否则调用上一行的相邻元素相加
def tri_element(row ,col):
	if col==1 or col==row:
		return 1
	else:
		return tri_element(row-1, col-1)+tri_element(row-1, col)

#产生杨辉三角的函数：传入参数为行数(int)，返回对称分布三角
def yangtri(n):
	strout = str()
	#通过指数估算最大项的位数的上界，并乘以n估算最长行总占位数的上界
	MLen = len(str(2**n))*n + n
	#每一行循环调用产生元素的函数，将所有的元素拼接、按上文估计的上界位数居中，输出
	for row in range(1, n+1):
		listrow = list()
		for col in range(1, row+1):
			listrow.append(tri_element(row, col))
		strout = strout + \
		(' '.join(list(map(str, listrow)))).center(MLen) + '\n'
	return strout

n = input()
print(yangtri(int(n)))


#日期戳：2017/4/6
		 
