import turtle
import random

t = turtle.Turtle()

w = turtle.Screen()
global m 
m = 0

def drawTree(n):
  if n < 5:
    mystamp() #画树叶或橘子
    return
  t.pensize(n/10+1) #调整树枝粗细，越往末端越细
  t.fd(n)
  right_angle = random.randrange(round(40-0.13*n))+15 #右转随机角度，最开始几次分叉有更紧的限制，避免整棵树明显分为两瓣
  right_length = random.randrange(10)+n*0.7-5 #控制树枝长度，越往末端越短
  t.right(right_angle)
  drawTree(right_length) #调用递归函数
  left_angle = random.randrange(round(40-0.13*n))+15 #左转随机角度，同右转
  left_length = random.randrange(10)+n*0.7-5  #控制树枝长度，同上
  t.left(left_angle + right_angle)
  drawTree(left_length) #调用递归函数
  t.right(left_angle)
  t.bk(n)

def mystamp():
    global m #引用全局变量m
    if m % 3 == 0:
      t.stamp() #每三个末梢画一片树叶
    if m % 15 == 0:
      t.shape('orange.gif')
      t.stamp() #每15个末梢画一个橘子
      t.shape('leaf.gif')
    m += 1

t.up()
t.goto(0,-350) #移动海龟到树根处
t.down()
t.setheading(90)
t.color('#8B4513') #树干颜色为棕色
t.pensize(10)
w.register_shape('leaf.gif') #引入树叶原图
w.register_shape('orange.gif') #引入橘子原图
t.shape('leaf.gif') #将海龟做成树叶形状
turtle.tracer(0)
drawTree(200)
turtle.update()
w.exitonclick()

