#!/usr/bin/env python3
# -*- coding: utf-8 -*-
def qsort(lst):
    if len(lst) <= 1:
        return lst
    return qsort([x for x in lst[1:] if x <= lst[0]]) + [lst[0]] + qsort([x for x in lst[1:] if x > lst[0]])

def findkth(lst,l,r,k):
    if l>=r:
        return lst[l]
    i,j=l,r
    pivot = lst[i] #用于比较的数，留出一个空位i
    while i<j:
        while i<j and lst[j] >= pivot:
            j -= 1 #从最右边开始找比pivot小的数
        if i<j:
            lst[i] = lst[j]#把右边比pivot小的数换到左边的空位中
            i += 1
        while i<j and lst[i] <= pivot:
            i += 1 #从最左边开始找比pivot大的数
        if i<j:
            lst[j] = lst[i]
            j -= 1 #把左边比pivot大的数换到右边的空位中
    lst[i] = pivot #把pivot放到最后留出的空位
    if i==k-1:
        return pivot #如果pivot是第k个数，直接返回
    elif i>k-1:
        return findkth(lst,l,i-1,k)#递归左半边
    elif i<k-1:
        return findkth(lst,i+1,r,k)#递归右半边
        
def find_kth_nlogn(lst,k):
    return qsort(lst)[k-1]

def find_kth_n(lst,k):
    return findkth(lst,0,len(lst)-1,k)