import turtle
def hilbert(count, minlen, t, heading):
    if count != 0:                              #如果为一阶以上曲线，就画四个低阶曲线和三条线段
        hilbert(count - 1, minlen, t, heading + (-1) ** (heading / 90 % 2) * 90)
        t.setheading(heading)                   #其中首尾两个低阶曲线和后两条线段的方向和上一阶曲线方向水平还是竖直有关
        t.fd(minlen)                            #其余低阶曲线和线段和上一阶曲线同向
        hilbert(count - 1, minlen, t, heading)
        t.setheading(heading + (-1) ** (heading / 90 % 2) * 90)
        t.fd(minlen)
        hilbert(count - 1, minlen, t, heading)
        t.setheading(heading + (-1) ** (heading / 90 % 2) * 180)
        t.fd(minlen)
        hilbert(count - 1, minlen, t, heading - (-1) ** (heading / 90 % 2) * 90)
t = turtle.Turtle()
myWin = turtle.Screen()
myWin.screensize(2000,1500)                     #设置画布尺寸
myWin.tracer(0)
count = 8                                       # 设置阶数
minlen = 2                                      # 设置最小线段长度
t.up()                                          #初始化使乌龟在左下角
t.ht()
t.bk((minlen * (2 ** count - 1)) / 2)
t.lt(90)
t.bk((minlen * (2 ** count - 1)) / 2)
t.down()
hilbert(count, minlen, t, 90)
myWin.update()
