import timeit
import random

for i in range (10000,1000001,10000):
    x = list(range(i)) #生成长度为i的列表
    getvalue = timeit.Timer('x[random.randrange(%d)]'%i,'from __main__ import random,x')
    #随机取值
    gvtime = getvalue.timeit(number=1000)#取值操作执行1000次的时间
    print('%d,%.5f' % (i,gvtime))

#输出结果后发现，随着序列长度的变化，所用的时间基本不发生改变，因此是O(1)
