import timeit
import random

for i in range(10000,1000001,10000):
    x = {j:None for j in range(i)}#生成长度为i,键为数字,值为None的字典
    getvalue = timeit.Timer('x[random.randrange(%d)]'%i,'from __main__ import random,x')
    #随机取字典中的某个键对应的值
    setvalue = timeit.Timer('x[random.randrange(%d)]=0'%i,'from __main__ import random,x')
    #随机将字典中的某个键对应的值更改为0
    get_time = getvalue.timeit(number=1000)#取值操作执行1000次的时间
    set_time = setvalue.timeit(number=1000)#赋值操作执行1000次的时间
    print("%d,%.5f,%.5f" % (i,get_time,set_time))
    
#输出结果后发现，随着序列长度的变化，取值操作和赋值操作的时间基本上不发生改变，因此都是O(1)
