import random
import timeit

def Searchwithslice(alist,data):#含有切片操作
    if len(alist) == 0:
        return False
    else:
        midpoint = len(alist)//2
        if alist[midpoint] == data:
            return True
        else:
            if data < alist[midpoint]:
                return Searchwithslice(alist[:midpoint],data)
            else:
                return Searchwithslice(alist[midpoint+1:],data)

def Searchwithoutslice(alist,data,first,last):#不含切片操作
    if last - first == 0:
        return False
    else:
        midpoint = (last - first)//2 + first
        if alist[midpoint] == data:
            return True
        else:
            if data < alist[midpoint]:
                return Searchwithoutslice(alist,data,first,midpoint)
            else:
                return Searchwithoutslice(alist,data,midpoint+1,last)
for i in range (10000,1000001,10000):#进行时间计算
    t = timeit.Timer("Searchwithslice(alist,random.randrange(%d))"%i,"from __main__ import random,alist,Searchwithslice")
    q = timeit.Timer("Searchwithoutslice(alist,random.randrange(%d),0,len(alist)-1)"%i,"from __main__ import random,alist,Searchwithoutslice")
    blist = [k for k in range(1,1000000)]
    random.shuffle(blist)
    alist = blist[:i]
    slicetime = t.timeit(number=10)
    noslicetime = q.timeit(number=10)

    print("%d\t%10.8f\t%10.8f"%(i,slicetime,noslicetime))




