class Stack:#定义栈
    def __init__(self):
        self.items = []

    def isEmpty(self):
        return self.items == []

    def push(self, item):
        self.items.append(item)

    def pop(self):
        return self.items.pop()

    def peek(self):
        return self.items[len(self.items)-1]

    def size(self):
        return len(self.items)
def infixtopostfixer(infix_expr):
    prec={}#通过数字大小定义符号优先级
    prec['^']=4
    prec['*']=3
    prec['/']=3
    prec['+']=2
    prec['-'] = 2
    prec['(']=1
    opStack=Stack()#
    numStack=Stack()#存放数字的栈
    tokenlist=infix_expr.split()#读入中缀表达式并转为列表
    for token in tokenlist:
        if token=='(':
            opStack.push(token)#如果是左括号就push进栈顶
        elif token==')':#如果是右括号就把之前的都pop出来
            topToken==opStack.pop()
            while topToken!='(':#直到遇到左括号
                num2=numStack.pop()
                num1=numStack.pop()
                result=domath(topToken,num1,num2)
                numStack.push(result)#把计算结果push进数字栈
                topToken=opStack.pop()
        elif token in'+-*/^':#运算
            if not opStack.isEmpty() and prec[token]<=prec[opStack.peek()]:#如果栈没空并且优先级低于栈顶的，就得先算栈顶的计算符
                topToken=opStack.pop()
                num2=numStack.pop()
                num1=numStack.pop()#把要算的两个数拿出来，注意顺序
                result=domath(topToken,num1,num2)#计算并把结果push进数字栈
                numStack.push(result)
                opStack.push(token)#然后再把符号压进栈
            else:
                opStack.push(token)
        else:
            numStack.push(int(token))#如果是数字，把数字存进栈
    while not opStack.isEmpty():#全都弹出去算
                num2=numStack.pop()
                num1=numStack.pop()
                topToken=opStack.pop()
                result=domath(topToken,num1,num2)
                numStack.push(result)
    return numStack.pop()#函数返回值

def domath(op,num1,num2):#计算函数
        if op=='^':
            return num1**num2
        elif op=='*':
            return num1*num2
        elif op=='/':
            return num1/num2
        elif op=='+':
            return num1+num2
        elif op=='-':
            return num1-num2
infix_expr=input()
print(infixtopostfixer(infix_expr))