import turtle
import random


def tree(branchLen, t, num):
    if branchLen > 5:  # 枝干小于5时停止
        if branchLen >= 80:  # 枝干大于80时是棕褐色
            t.color("#996600")
        elif 80 > branchLen >= 60:  # 枝干小于80大于60按概率出现颜色
            if random.randint(1, 10) > 5:
                t.color("#996600")
            else:
                t.color("#CC0000")
        else:
            t.color("#CC0000")
        if num > 2:  # 控制枝干的粗细
            t.pensize(num)
            t.forward(branchLen)
            num -= 2
        else:
            t.pensize(2)
            t.forward(branchLen)
        m = random.randint(10, 30)  # 控制枝干倾斜度在10到30度随机出现
        t.right(m)
        tree(branchLen-8, t, num)  # 每次枝干减少8
        n = random.randint(30, 50)
        t.left(n)
        tree(branchLen-8, t, num)
        t.right(n-m)

        if branchLen < 20:  # 当枝干小于20时按一定概率生成红色的六瓣花
            p = random.randint(1, 10)
            if p>8:
                flower(t, 1, 100)
        elif 20 < branchLen <= 30:  # 枝干在20到30之间以更小的概率生成花
            q = random.randint(1, 20)
            if q > 18:
                flower(t, 1, 100)

        t.penup()  # 海龟退回之前抬起笔
        t.backward(branchLen)
        t.pendown()  # 放下笔


def flower(t, length, n):  # 花红色的六瓣花
    t.color("#FF0099")
    t.begin_fill()
    for j in range(6):  # 花有六瓣
        num = n
        for i in range(2):
            for i in range(num // 4):
                t.right(360.0 / n)
                t.forward(length)
            t.right(90)
        t.left(60)
    t.end_fill()


def main():
    t = turtle.Turtle()
    myWin = turtle.Screen()
    turtle.tracer(0)
    turtle.update()
    t.left(90)
    t.up()
    t.backward(400)
    t.down()
    tree(100, t, 12)
    myWin.exitonclick()
main()
