def museum(treasure,maxw):
    lens=len(treasure)
    # 创建二维列表，横向为重量，竖向为数目
    value=[[j for j in range(maxw+1)] for i in range(lens+1)]
    # 数目或承重为零时，价值均为零
    for j in range(maxw+1):
        value[0][j]=0
    for i in range(lens+1):
        value[i][0]=0
    # 数目，承重均不为零的情况
    for i in range(1,lens+1):
        for j in range(1,maxw+1):
            # 重量不能承担担起第件宝物
            value[i][j] = value[i-1][j]
            # 重量可以承担第i个宝物，比较不承担此件宝物的价值和承担此件宝物所对应的价值
            if j >= treasure[i-1]['w'] and value[i][j] < ( value[i-1][j-treasure[i-1]['w']] + treasure[i-1]['v']):
                value[i][j] = value[i-1][j-treasure[i-1]['w']] + treasure[i-1]['v']
    # 输出总价值
    print('最高总价值：')
    print(value[lens][maxw])
    # found 为 判断第i件宝物是否被拿走
    found = [False] * lens
    j = maxw
    # 从最大重量开始循环
    for i in range(lens,0,-1):
        # 若去除此件宝物后价值减小，说明此件宝物被拿走
        if value[i][j] > value[i-1][j]:
            found[i-1] = True
            j -= treasure[i-1]['w']
    # 打印被拿走宝物的序号和价值
    print('被拿走的宝物序号及价值：')
    for i in range(lens):
        if found[i]:
            print('%d'%(i), ':' ,treasure[i]['v'])

treasureList = [{'w':2,'v':3},{'w':3,'v':4},{'w':4,'v':8},{'w':5,'v':8},{'w':9,'v':10}]
museum(treasureList,20)
