import random
import turtle


def leaf(t,color):
    colormap = ["Yellow","Green","Orange"]
    j = random.randint(0,2)
    t.fillcolor(colormap[j])
    t.begin_fill()
    t.up()
    angle3 = random.randint(0,180)
    t.left(angle3)
    t.left(15)
    t.forward(20)
    t.right(30)
    t.forward(20)
    t.right(150)
    t.forward(20)
    t.right(30)
    t.forward(20)
    t.left(195-angle3)
    t.end_fill()
    t.down()

def tree(branchlen,t,i):
    if branchlen > 8:
        t.color("black")
        t.pensize(i)
        t.forward(branchlen)
        leaf(t,"Green")
        angle = random.randint(10,60)
        t.right(angle)
        tree(branchlen-12,t,i-0.6)
        t.left(angle)
        tree(branchlen-12,t,i-0.6)
        angle2 = random.randint(10,60)
        t.left(angle2)
        tree(branchlen-12,t,i-0.6)
        t.right(angle2)
        t.up()
        t.backward(branchlen)
        t.down()

def main():
    turtle.tracer(0)
    t = turtle.Turtle()
    myWin = turtle.Screen()
    t.left(90)
    t.up()
    t.backward(200)
    t.down()
    tree(92,t,5.6)
    myWin.exitonclick()
    turtle.update()

main()