import turtle
from random import randint
def Hilbert(heading,degree,t,b):
     if degree==0:#若degree为0，画出0阶Hilbert曲线
          t.setheading(heading)
          t.fd(b)
          t.right(2*(heading%180)-90)#当heading取90 or 270时，逆时针方向
          t.fd(b)#当heading取0 or 180，顺时针方向
          t.right(2*(heading%180)-90)
          t.fd(b)
     else:
          #degree不为0，则在适当的位置调用（degree-1）
          #仍需考虑heading取值对方向的影响
          newdirection=90-2*(heading%180)
          t.setheading(heading)
          Hilbert(heading+newdirection,degree-1,t,b)
          t.setheading(heading)
          t.fd(b)
          Hilbert(heading,degree-1,t,b)
          t.setheading(heading+newdirection)
          t.fd(b)
          Hilbert(heading,degree-1,t,b)
          t.setheading(180+heading)
          t.fd(b)
          Hilbert(heading-newdirection,degree-1,t,b)     
          return
def drawsquare(point,turtle):#画正方形
     turtle.up()
     turtle.goto(point[0])
     turtle.down()
     turtle.goto(point[1])
     turtle.goto(point[2])
     turtle.goto(point[3])
     turtle.goto(point[0])
     turtle.up()
     return

degree=int(input("你想画几阶希尔伯特曲线？"))
a=int(input('希尔伯特曲线的最小边长a=？'))
lenth=a*2**degree+a/2
t=turtle.Turtle()
mywin=turtle.Screen()
mywin.screensize(2000,1500)#设置屏幕大小
mywin.tracer(0)
mywin.colormode (255)#颜色随机变化
t.color(randint(0,255),randint(0,255),randint(0,255))
point=[(-lenth,-lenth),(-lenth,lenth),(lenth,lenth),(lenth,-lenth)]
t.pensize(a/2)
drawsquare(point,t)
t.goto(-lenth+a,-lenth+a)
t.down()
Hilbert(90,degree,t,a)
mywin.update()
mywin.exitonclick()
