import turtle
n=10              #n为要挪动的河内塔的层数
t=['0']*n        #为了之后设置n个turtle
a=['red','black','blue','pink','yellow','green']*(n//6+1)#为不同的层设置颜色
for i in range(n):          #定义每一层的海龟
    t[i] = turtle.Turtle()
    t[i].hideturtle()        #在设置是现将海龟隐藏
    t[i].up()
    t[i].goto(-300,0-20*i)    #把海龟摞起来
    t[i].down()
    t[i].color(a[i])
    t[i].shape('circle')
    t[i].shapesize(1, i + 1, 4) #设置海龟的颜色，形状和大小
    t[i].showturtle()      #使海龟显现出来
my=turtle.Screen()
def movetower(height,frompole,topole,withpole):  #定义递归的河内塔函数
    if height>=1:     #当大于等于一片时，进行递归
        movetower(height-1,frompole,withpole,topole)
        movedisk(height-1,frompole,topole)
        movetower(height-1,withpole,topole,frompole)
def movedisk(i,fp,tp):#使海龟移动
    fp[2]=fp[2]-1  #fp[2]和tp[2]用于记录这两根棍子上有几个盘子
    tp[2]=tp[2]+1
    d=tp[1]+20*tp[2]  #确定盘子要放到的高度
    t[i].up()
    t[i].goto(tp[0],d)  #拿起第i个盘子，并将其移动到指定的位置
    t[i].down()
frompole=[-300,-20*n,n]  #三个数分别表示x坐标，y坐标和盘子的个数
topole=[0,-20*n,0]
withpole=[300,-20*n,0]
movetower(n,frompole,topole,withpole) #执行函数
my.exitonclick()