import random
import timeit
#不切片递归二分搜索
def Ncutbinary(alist,start,end,item):
    #左标小于右标即搜索结束，递归结束
    if start<end:
        return False
    #否则，二分搜索
    #若中值就是item，搜索成功
    else:
        midpoint=(start+end)//2
        if alist[midpoint]==item:
            return True
    #没找到，递归
        elif alist[midpoint]>item:
            return Ncutbinary(alist,start,midpoint,item)
        else:
            return Ncutbinary(alist,midpoint,end,item)

#切片递归二分搜索
def cutbinary(alist,item):
    #若列表长度为0，则已搜索完成，递归结束
    if len(alist)==0:
        return False
    #否则，二分搜索
    else:
        midpoint=len(alist)//2
    #若中值是item，则搜索成功
        if alist[midpoint]==item:
            return True
    #否则，切片，递归
        else:
            if item<alist[midpoint]:
                return cutbinary(alist[:midpoint],item)
            else:
                return cutbinary(alist[midpoint:],item)
#随机生成一个有序的自然数列表
mylist=[]
lastrandom=0
for i in range(500000):
    cutrandom=random.randint(lastrandom,100000000000)
    mylist.append(cutrandom)
    lastrandom=cutrandom
#计时实验
Ncutsearch=timeit.Timer("Ncutbinary(mylist,0,len(mylist)-1,10000)",\
                       "from __main__ import mylist,random,Ncutbinary")
cutsearch=timeit.Timer("cutbinary(mylist,10000)",\
                       "from __main__ import mylist,random,cutbinary")
Ncuttime=Ncutsearch.timeit(number=500)
cuttime=cutsearch.timeit(number=500)
print("%1.8f,%1.8f" % (Ncuttime,cuttime))
#计时实验结果：不切片的效率是切片效率的30000倍[LOL]