import turtle
import random

t = turtle.Turtle()
myWin = turtle.Screen()
t.left(90)
t.up()
t.backward(300)
t.down()

global first
first = 0


def Tree1(Len,t,Num):    #树的主体部分。。。
    if Num >= 2:    #递归进行的条件
        t.color('dark green')
        t.pensize(Len/14)
        if first == 0:
            t.pensize(3 + Len/14)
        t.forward(Len)
        Tree1(Len-1, t, Num - 2)     #递归调用

        global first
        if first == 0:     #标记第一次（即树的主干部分），绘制五角星
            t.color('yellow')
            t.fillcolor('yellow')
            t.begin_fill()
            t.left(200)
            for i in range(5):
                t.forward(45)
                t.right(144)
                first = 1
            t.right(200)
            t.end_fill()
            t.color('dark green')

        t.right(120)
        Tree1(Len-2, t,Num - 4)    #递归调用
        t.right(120)
        Tree1(Len-2, t,Num - 4)    #递归调用
        t.right(120)
        t.up()
        t.backward(Len)
        t.down()
    else:
        n = random.randint(0,300)
        if n in [1,3,4,5,6,7,8]:    #随机在圣诞树上增加各种装饰，这里时一个圆环
            t.pensize(2.5)
            t.color('yellow')
            t.circle(10)
            t.pensize(0)
            t.color('red')
            t.begin_fill()
            t.circle(2)
            t.end_fill()
            t.begin_fill()
            t.circle(3)
            t.end_fill()
        elif n == 2:   #在圣诞树上增加蝴蝶结，两个三角形
            t.color('red')
            t.begin_fill()
            mid = random.randint(10,18)
            for i in range(0,3):
                t.forward(mid)
                t.right(120)
            t.right(180)
            for i in range(0,3):
                t.forward(mid)
                t.right(120)
            t.right(180)
            t.end_fill()
            t.begin_fill()
            t.color('black')
            t.circle(1.5)
            t.end_fill()
            t.color('dark green')


def snowflake(lengthSide, levels,tr):   #koch曲线，基本原理还是递归，这里借鉴百度百科
    if levels == 0:    #递归结束条件
        tr.forward(lengthSide)
        return
    lengthSide /= 3.0
    snowflake(lengthSide, levels - 1,tr)
    tr.left(60)
    snowflake(lengthSide, levels - 1,tr)
    tr.right(120)
    snowflake(lengthSide, levels - 1,tr)
    tr.left(60)
    snowflake(lengthSide, levels - 1,tr)


def full_snowflake(lengthside, levels,tr):
    for i in range(3):
        snowflake(lengthside, levels,tr)
        tr.right(120)


for i in range (0,20):     #随机位置，调用函数，绘制随机大小的雪花
    tr = turtle.Turtle()
    myWin = turtle.Screen()
    tr.speed(10000)
    tr.color('blue')
    tr.pensize(0.01)
    tr.fillcolor('light blue')
    length = random.randint(40,60)
    tr.penup()
    tr.backward(random.randint(-600,600))
    tr.left(90)
    tr.backward(random.randint(-300,300))
    tr.pendown()
    tr.begin_fill()
    full_snowflake(length, 3, tr)
    tr.end_fill()
    tr.color('white')


t.color('dark green')
t.pensize(6)
t.forward(100)
t.speed(10000)
t.forward(50)
Tree1(38,t,26)
myWin.exitonclick()
