# 读入物品件数
n = int(input('请输入一个正整数作为物品件数\n'))
contain = int (input('请输入一个正整数作为背包的容量\n'))

# 定义物品类，含有两个参数：价格和重量
class thing:
    def __init__(self, weight, price):
        self.weight = weight
        self.price = price

# 创建一个列表用来陈列物品
thinglist = []
# 读入每件物品的重量和价值
for i in range(0, n):
    t = thing(int(input("请输入第%d号物品的重量:"% (i))), int(input("请输入第%d号物品的价值:" % (i))))
    thinglist.append(t)

# 创建一个二维背包列表用来存放入背包的物品的序号，所有位置初始为空列表
packagelist = []
for j in range(0, n+1):
    packagelist.append([])
for i in range(0, n+1):
    for k in range(0, contain+1):
        packagelist[i].append([])



# 创建用来储存结果的二重列表，resultlist[i][j]表示对前i件物品，容量为j的背包问题的最优解,所有元素初始为0
resultslist = []
for i in range(0, n+1):
    resultslist.append([0, ])
for x in range(0, n + 1):
    for y in range(1, contain + 1):
        resultslist[x].append(0)

# i表示考虑前i个物品，j表示考虑容量为j的背包
for i in range(1, n + 1):
    for j in range(1, contain+1):
        bestprice = resultslist[i - 1][j]
        bestpackage = packagelist[i - 1][j].copy()

        if thinglist[i - 1].weight <= j:
            if thinglist[i - 1].price + resultslist[i - 1][j - thinglist[i-1].weight] > bestprice:
                bestprice = thinglist[i - 1].price + resultslist[i - 1][j - thinglist[i - 1].weight]
                bestpackage = packagelist[i - 1][j - thinglist[i - 1].weight] + [i - 1]

        resultslist[i][j] = bestprice
        packagelist[i][j] = bestpackage.copy()

print(resultslist[n][contain])
print("偷走物品的序号为：")
print(packagelist[n][contain])



