# coding=utf-8
# 递归树:Ginkgo
# 请全屏观看

import turtle
import random
import math

def tree(branchlen,art):
    if branchlen>15:
        art.color(color(branchlen))  # 分段上色
        art.pensize(branchlen / 5)  # 树枝粗细与长度成正比
        if branchlen>40:
            status=random.randrange(1,6)
        else:
            status=1
        rightangle = randangle(branchlen)
        leftangle = randangle(branchlen)  # 随机左右转角
        if 2<=status<=4:  # 随机分两叉或三叉或不分叉
            art.forward(branchlen)
            art.right(rightangle)
            tree(reduct(branchlen),art)
            art.left(leftangle+rightangle)
            tree(reduct(branchlen),art)
            art.right(leftangle)
            art.color(color(branchlen))
            art.pensize(branchlen/5)
            art.backward(branchlen)
        elif status==5:
            art.forward(branchlen)
            art.right(rightangle)
            tree(reduct(branchlen), art)
            art.left(rightangle)
            tree(reduct(branchlen), art)
            art.left(leftangle)
            tree(reduct(branchlen), art)
            art.right(leftangle)
            art.color(color(branchlen))
            art.pensize(branchlen / 5)
            art.backward(branchlen)
        else:
            art.forward(branchlen)
            tree(reduct(branchlen), art)
            art.color(color(branchlen))
            art.pensize(branchlen / 5)
            art.backward(branchlen)
    else:
        ginkgoleaf(math.ceil(2*branchlen),art)

def leaf(size,color,art):
    art.color(color)
    art.pensize(size)
    pos=art.position()
    for i in range(size):
        art.forward(1)
        art.pensize(art.pensize()-1)
    art.setposition(pos)

def ginkgoleaf(size,art):
    art.pensize(1)
    art.color("yellow")
    start=art.position()
    art.forward(size)
    center=art.position()
    art.left(180)
    leaf(size,'yellow',art)
    art.right(75)
    art.forward(size/2)
    art.left(108)
    leaf(math.ceil(size/1.2), 'yellow', art)
    art.setposition(center)
    art.left(42)
    art.forward(size/2)
    art.right(108)
    leaf(math.ceil(size/1.2), 'yellow', art)
    art.setposition(start)
    art.right(147)

def color(branchlen):
    if branchlen>=20:
        return "gray"
    else:
        return "gray"

def reduct(branchlen):
    if branchlen>=100:
        return branchlen/(1+random.randrange(25,75)/100)
    elif branchlen>=35:
        return branchlen-10-random.randrange(2,8)
    else:
        return branchlen-4-random.randrange(1,3)

def randangle(branchlen):
    if branchlen>=100:
        return random.randrange(10,20)
    else:
        return random.randrange(15,40)

iris=turtle.Turtle()
wnd=turtle.Screen()
iris.speed(10)
iris.left(90)
iris.up()
iris.backward(320)
iris.down()
tree(180,iris)
wnd.exitonclick()