# coding=utf-8
# 递归树:World
# 请全屏观看

import turtle
import random
import math
colorlist=["red","orange","yellow","aqua","green","blue",\
           "indigo","purple","pink","brown","black","gray"]

def tree(branchlen,art):
    if branchlen>5:
        art.color("brown")
        art.pensize(branchlen / 5)  # 树枝粗细与长度成正比
        if branchlen>40:
            status=random.randrange(1,6)
        else:
            status=1
        rightangle = randangle(branchlen)
        leftangle = randangle(branchlen)  # 随机左右转角
        if 2<=status<=4:  # 随机分两叉或三叉或不分叉
            art.forward(branchlen)
            art.right(rightangle)
            tree(reduct(branchlen),art)
            art.left(leftangle+rightangle)
            tree(reduct(branchlen),art)
            art.right(leftangle)
            art.color("brown")
            art.pensize(branchlen/5)
            art.backward(branchlen)
        elif status==5:
            art.forward(branchlen)
            art.right(rightangle)
            tree(reduct(branchlen), art)
            art.left(rightangle)
            tree(reduct(branchlen), art)
            art.left(leftangle)
            tree(reduct(branchlen), art)
            art.right(leftangle)
            art.color("brown")
            art.pensize(branchlen / 5)
            art.backward(branchlen)
        else:
            art.forward(branchlen)
            tree(reduct(branchlen), art)
            art.color("brown")
            art.pensize(branchlen / 5)
            art.backward(branchlen)
    else:
        if branchlen<=1:
            branchlen=2
        randcolor=colorlist[random.randrange(12)]
        fruit(math.ceil(10*branchlen),randcolor,art)

def fruit(size,color,art):
    art.color(color)
    art.pensize(size)
    art.forward(1)
    art.backward(1)

def reduct(branchlen):
    if branchlen>=100:
        return branchlen/(1+random.randrange(25,75)/100)
    elif branchlen>=35:
        return branchlen-10-random.randrange(2,8)
    else:
        return branchlen-4-random.randrange(1,3)

def randangle(branchlen):
    if branchlen>=100:
        return random.randrange(10,20)
    else:
        return random.randrange(15,40)

iris=turtle.Turtle()
wnd=turtle.Screen()
iris.speed(10)
iris.left(90)
for direc in range(12):
    tree(90,iris)
    iris.goto(0,0)
    iris.left(30)

wnd.exitonclick()