# coding=utf-8
# 无规行走树:Turing
# 请全屏观看

import turtle
import random

turing="TURING"

steps=0
w = turtle.Screen()
cs=turtle.Turtle()
cs.left(90)
cs.up()
cs.backward(300)
cs.down()
cs.pensize(15)
cs.forward(260)  # 树干
for times in range(50):
    cs.up()
    cs.goto(0,-40)
    cs.down()
    for step in range(10):
        cs.pensize(11-step)
        pos=cs.position()
        motion=random.randrange(0,4)
        # 随机数决定延伸方向
        if motion==0 or motion==1:
            cs.goto(pos[0],pos[1]+50)
        elif motion==2:
            cs.goto(pos[0]-50,pos[1])
        else:
            cs.goto(pos[0]+50,pos[1])
        cs.write(turing[steps%6],False,"center",("Arial",20,"normal"))
        # 书写“TURING”字母之一
        steps+=1
# 书写结束语
cs.up()
cs.goto(0,-350)
cs.write("In Memory of Alan M. Turing",False,"center",("Times New Roman",32,"normal"))
cs.hideturtle()
w.exitonclick()