#list dic 删除操作   O（?）
import timeit                        #模块导入
import ran

for i in range(1500000,4000000,10000):   #生成不同长度的列表和字典,注意当长度太小时很容易重复删除掉同一个随机数，这样就尴尬了。。所以要大一些
    x=list(range(i))
    y={j:None  for j in range(i)}
                                     #对两种操作分别计时
    listdel=timeit.Timer("del(x[random.randrange(1500000)])", "from __main__ import x,random")
    dictdel=timeit.Timer("del(y[random.randrange(1500000)])", "from __main__ import y,random")
    t_listdel=listdel.timeit(number=100)
    t_dictdel=dictdel.timeit(number=100)
    print("%10.d %15.5f %15.5f"%(i,t_listdel,t_dictdel))