# -*- coding: utf-8 -*-
class Vector3:   # 定义Vector3类
    def __init__(self, x, y, z):
        self.x = x
        self.y = y
        self.z = z

    def __add__(self, obj):   # 定义三阶向量加法
        return Vector3(self.x + obj.x, self.y + obj.y, self.z + obj.z)

    def __sub__(self, obj):   # 定义三阶向量减法
        return Vector3(self.x-obj.x, self.y-obj.y, self.z-obj.z)

    def __mul__(self, obj):   # 定义三阶向量与标量的乘法
        return Vector3(self.x * obj, self.y * obj, self.z * obj)

    def __truediv__(self, obj):   # 定义三阶向量与标量的除法
        x = self.x / obj
        y = self.y / obj
        z = self.z / obj
        return Vector3(x, y, z)

    def __str__(self):   # 定义str输出为向量的格式
        return '(%s,%s,%s)' % (self.x, self.y, self.z)


data = input().split(' ')
s1, s2, m, n = eval(data[0]), eval(data[1]), int(data[2]), int(data[3])
v1 = Vector3(s1[0], s1[1], s1[2])
v2 = Vector3(s2[0], s2[1], s2[2])
print(str(v1 + v2) + ' ' + str(v1 - v2) + ' ' + str(v1 * m) + ' ' + str(v1 / n))
