from UnorderList import UnorderedList

class ADTQueue(UnorderedList): #ADTStack 用无序表来实现队列的功能，其中队列的直接继承自无序表
    def isempty(self): #判断队列是否为空
        if self.size()>0:
            return False
        else:
            return True

    def enqueue(self,num): #向队列中加入一个元素，实际上与无序表的add方法完全相同
        return self.add(num)

    def peek(self):#访问队首的元素
        length = self.size()  # 先确定无序表的长度，然后按这个长度向后遍历
        current = self.head
        for i in range(length - 1):
            current = current.getNext()
        return current.getData()

    def dequeue(self):
        assert not self.isempty()
        length = self.size()  # 先确定无序表的长度，然后按这个长度向后遍历
        current = self.head
        for i in range(length - 2):
            current = current.getNext()
        output=current.getNext()
        current.setNext(None)
        return output.getData()  # 遍历了所有元素后，得到的就是表尾元素

rawinput = input().split()
mylist=ADTQueue()
for i in rawinput:
    mylist.add(i)
print("输入的队列为:")
print(mylist)
print("输入的队列的大小为:")
print(mylist.size())
print("从队列中输出一个元素为:")
print(mylist.dequeue())
print("队列的大小为:")
print(mylist.size())
mylist.enqueue(6)
print("现在的队列为:")
print(mylist)
print("现在队列的队首元素为")
print(mylist.peek())
print("判断栈是否为空:")
print(mylist.isempty())