from UnorderList import UnorderedList

class ADTStack(UnorderedList): #ADTStack 用无序表来实现栈的功能，其中栈的size，pop方法直接继承自无序表
    def isempty(self):
        if self.size()>0:
            return False
        else:
            return True

    def push(self,num): #向栈中压入一个元素，实际上与无序表的add方法完全相同
        return self.add(num)

    def peek(self):
        assert not self.isempty()#当栈为空的时候，不能使用peek方法
        m=self.head
        return m.getData()

rawinput = input().split()
mylist=ADTStack()
for i in rawinput:
    mylist.add(i)
print("输入的栈为:")
print(mylist)
print("输入的栈的大小为:")
print(mylist.size())
print("从栈中弹一个元素为:")
print(mylist.pop())
print("栈的大小为:")
print(mylist.size())
print("栈顶的元素为:")
print(mylist.peek())
mylist.push(6)
print("判断栈是否为空:")
print(mylist.isempty())
