from Node import Node

class UnorderedList1:
    def __init__(self): #此处是UnorderedList的初始化方法
        self.head = None

    def add(self,item): #定义UnorderedList的add方法——从无序表头加入新元素
        temp = Node(item)
        temp.setNext(self.head)
        self.head = temp

    def size(self): #定义UnorderedList的size方法——返回无需表中的元素个数
        count=0
        current=self.head
        while current != None:
            count = count + 1
            current = current.getNext()
        return count

    def tail(self):  #tail方法：返回无序表表尾的元素
        length = self.size() #先确定无序表的长度，然后按这个长度向后遍历
        current = self.head
        for i in range(length-1):
            current = current.getNext()
        return current #遍历了所有元素后，得到的就是表尾元素

