from pythonds.basic.stack import Stack#可以支持多位整数运算，同时也可以支持乘方运算


def docalculate(infixexpr):  #此处开始定义做运算的函数
    prec={} #字典prec用来定义每一种运算的优先级
    prec["^"]=4
    prec["*"]=3
    prec["/"]=3
    prec["+"]=2
    prec["-"]=2
    prec["("]=1
    num3=0
    numberstack=Stack() #numberstack栈用来暂存操作数
    fixstack=Stack()  #fixstack栈用来暂存运算符
    sign=[]#sign是一个预先准备好的列表，之后使用到的时候会具体说明
    tokenlist=infixexpr.split() #tokenlist是一个把运算式转化成列表的式子

    for token in tokenlist:
        if token.isdigit():  #当从算式中读到数字时
                numberstack.push(int(token))
        elif token=="(":  #左括号压入栈中，起到隔离括号前后运算符和数字关系的作用
            fixstack.push(token)
        elif token==")": #读到后括号时
            toptoken=fixstack.pop() #开始将运算符栈中，直到上一个前括号前的运算符全部弹出并做运算
            while toptoken!="(":
                num1 = numberstack.pop()
                num2 = numberstack.pop()
                num3=domath(toptoken,num2,num1)
                numberstack.push(num3)
                toptoken=fixstack.pop()
        else: #读到运算符的话，比较运算符和栈顶运算符的优先级关系
            while (not fixstack.isEmpty()) and (prec[token]<prec[fixstack.peek()]):#若栈顶运算符的优先级高于所读到的运算符的话
                num1=numberstack.pop()
                num2=numberstack.pop()
                num3=domath(fixstack.pop(),num2,num1)#就将栈顶运算符弹出，同操作数栈栈顶的两个两个操作数做运算
                numberstack.push(num3)
            fixstack.push(token)

    while numberstack.size()!=1:  #当所有的操作数和运算符全部入栈后，逐一出栈并计算
        num1=numberstack.pop()
        num2=numberstack.pop()
        num3=domath(fixstack.pop(),num2,num1)
        if numberstack.size()==0:
            break
        numberstack.push(num3)
    return num3

def domath(op,op1,op2): #这里是定义做计算的函数
    if op=="+":
        return op1+op2
    elif op=="-":
        return op1-op2
    elif op=="*":
        return op1*op2
    elif op=="/":
        return op1/op2
    elif op=="^":
        return op1**op2

sentence=input()
print(int(docalculate(sentence)))