#w[]:物品的重量列表
#v[]；物品的价值列表
#决策树的思想:用一组向量来描述当前的状态，[当前考虑的物品i, 当前背包的空间w， 当前已获得的价值v]
#决策树左儿子表示不选取当前物品np，右儿子表示选取当前物品p，
# 首先递归到索引为最后一个的物品，然后回溯，每回溯到一个物品时候就比较选取当前物品和不选取当前物品哪个更有价值
#memo[(i,ws)]:来描述决策树中每种情况，同时保存对应的值。
memo = {}
def maxVal(w,v,i,ws):
    try:#异常处理，try捕获异常后，交由except处理#
        return memo[(i,ws)]
    except KeyError:

       if i == 0:
            if w[i] <= ws:
                memo[(i,ws)] = v[i]
                return v[i]
            else:
                memo[(i,ws)] = 0
                return 0
    without_i = maxVal(w,v,i-1,ws)#用递归算出不选取当前物品时候价值
    if w[i] > ws:#若所考虑的物品的重量大于目前可用的背包质量
            memo[(i,ws)] = without_i#直接将不选取当前物品的状态作为当前状态#
            return without_i#返回不选取当前物品的状态#
    else:
        with_i = maxVal(w,v,i-1,ws - w[i]) + v[i]#用递归算出选取当前物品时候的价值
    res = max(without_i,with_i)#选取二者的质量的最大值#
    memo[(i,ws)] = res#记录当前状态#
    return res
w = [5,3,2]
v = [9,7,8]
val = maxVal(w,v,2,5)
print(val)