from pythonds.basic.stack import Stack
import turtle
w = turtle.Screen()

height = int(input()) #盘子总数量
PoleList = []
for j in range(3):
    pole = Stack()
    PoleList.append(pole)
colorList = ["red","orange","yellow","green","cyan","blue","purple"] #盘子依次颜色以区分
for i in range(height): #生成方块形盘子,并依次放在最左边的柱子上
    disk = turtle.Turtle()
    disk.shape("square")
    disk.pensize(1)
    disk.color(colorList[i%7])
    disk.left(90)
    disk.up()
    disk.forward(200)
    disk.left(90)
    disk.forward(200)  #盘子放到最左边
    disk.left(90)
    disk.forward(20*(height-i)) #盘子在左边从下到上
    disk.right(180)
    PoleList[0].push(disk)

def moveTower(height,fromPole,toPole,withPole):
    if height>=1:
        moveTower(height-1,fromPole,withPole,toPole)
        moveDisk(fromPole,toPole)
        moveTower(height-1,withPole,toPole,fromPole)

def moveDisk(fromPole,toPole):
    moving = fromPole.pop()
    moving.penup()
    # 从from杆上拿下来
    moving.forward(20 * (height - fromPole.size()))
    #如果赶序号变大，向右移动
    if PoleList.index(fromPole) < PoleList.index(toPole):
        moving.right(90)
        moving.forward(200*(PoleList.index(toPole)-PoleList.index(fromPole)))
        moving.right(90)
    else:
        moving.left(90)
        moving.forward(200 * (PoleList.index(fromPole) - PoleList.index(toPole)))
        moving.left(90)
    #套在to杆上
    moving.forward(20 * (height - toPole.size()))
    moving.right(180)
    toPole.push(moving)

moveTower(height,PoleList[0],PoleList[2],PoleList[1])
w.exitonclick()