import turtle
import random
def leave(tree):
    tree.pensize(1)
    heading = tree.heading()
    position = tree.pos()
    tree.color((0.5,1,0))
    if random.randint(0,1) == 1:
        tree.right(random.randint(20,35))
        tree.forward(random.randint(3, 6))
        tree.right(13)
        tree.forward(random.randint(2, 4))
        tree.goto(position)
        tree.setheading(heading) #第一片绿叶
        tree.right(random.randint(45, 60))
        tree.forward(random.randint(6, 9))
        tree.right(13)
        tree.forward(random.randint(3, 5))
        tree.goto(position)
        tree.setheading(heading) #第二片
        tree.right(random.randint(75, 90))
        tree.forward(random.randint(4, 7))
        tree.right(13)#再输出第n行的数字
        tree.forward(random.randint(3, 6))
        tree.goto(position)
        tree.setheading(heading) #第三片
        tree.right(random.randint(105,120))
        tree.forward(random.randint(4,7))
        tree.right(13)
        tree.forward(random.randint(3,5))
        tree.goto(position)
        tree.setheading(heading)
        if random.randint(0,3) == 1:
            tree.right(random.randint(135,150))
            tree.forward(random.randint(3,6))
            tree.right(13)
            tree.forward(random.randint(3,5))
    else:
        tree.left(random.randint(10, 25))
        tree.forward(random.randint(4, 7))
        tree.left(13)
        tree.forward(random.randint(3, 5))
        tree.goto(position)
        tree.setheading(heading)
        tree.left(random.randint(35, 50))
        tree.forward(random.randint(5, 8))
        tree.left(13)
        tree.forward(random.randint(3, 5))
        tree.goto(position)
        tree.setheading(heading)
        tree.left(random.randint(65, 80))
        tree.forward(random.randint(4, 7))
        tree.left(13)
        tree.forward(random.randint(3, 5))
        tree.goto(position)
        tree.setheading(heading)
        tree.left(random.randint(105, 120))
        tree.forward(random.randint(4, 7))
        tree.left(13)
        tree.forward(random.randint(3, 5))
        tree.goto(position)
        tree.setheading(heading)
        if random.randint(0,3) == 1:
            tree.left(random.randint(135,150))
            tree.forward(random.randint(3,5))
            tree.left(13)
            tree.forward(random.randint(3,5))
    tree.goto(position)
    tree.setheading(heading)

def brunch(tree, level):
    if level > 0:
        position = tree.pos()
        heading = tree.heading()
        tree.pensize(level*1.2)
        tree.color((0.2,0.1,0.1))
        if level > 3:
            tree.forward(random.randint(level * 9, level * 12))
        else:
            tree.forward(random.randint(level * 13, level * 15))
        if 4 < level < 8:
            if random.randint(0, 1) == 1:
                tree.right(random.randint(25, 35))
            else:
                tree.left(random.randint(25, 35))
            brunch(tree, random.randint(2, 3))
        tree.setheading(heading)
        tree.right(random.randint(-5, 5))
        brunch(tree, level - 1)
        if level > 7 or (4 < level <= 7 and random.randint(0,2) == 1): #在一定条件下可以长稍小的树枝
            if random.randint(0, 1) == 1:
                tree.right(random.randint(25, 35))
            else:
                tree.left(random.randint(25, 35))
            brunch(tree,level-3)
        if level < 5:
            leave(tree)  # 树枝足够小时可以长嫩叶
            tree.pensize((level*1.2))
            tree.color((0.2,0.1,0.1))
        tree.penup()
        tree.goto(position)
        tree.pendown()
        tree.setheading(heading)

tree = turtle.Turtle()
Win = turtle.Screen()
Win.tracer(0)

tree.right(90)
tree.penup()
tree.forward(300)
tree.left(180)
tree.pendown() #飞到画面底部再开始长树
tree.color((0.2,0.1,0.1))
tree.pensize(9*1.2) # 确定树的颜色和树干大小
tree.forward(40)
brunch(tree,9)
tree.color((0,0,0))


Win.update()
Win.exitonclick()