from  Unorderedlist import  Node#调用Unorderedlist文件中的Unorderedlist类型，Unorderedlist文件中保存了已经实现的所有无序表操作

from Unorderedlist import UnorderedList#调用Unorderedlist文件中的Node类型

class OrderedList(UnorderedList):#定义OrderedList，以UnorderedList为父类
    def search(self,item):#重新定义search操作，此处采用的是有序表中变量为数，按从小到大的顺序排列
        current=self.head#current为遍历无序表的变量
        found=False#found为是否找到item的布尔值，初始为Fals
        stop=False#stop为是否停止的布尔值，初始为False
        while current!=None and not found and not stop:#若没有到表尾且没有找到item且不需要停下
            if current.getData()==item:#若current的值为item
                found=True#找到变量，found变为True
            else:#否则的话
                if current.getData()>item:#若current的值已经大于item，因为有序表是从小到大排列，说明之后的表中也不会有item了，则可以停止
                    stop=True#stop变为True
                else:#若current的值没有大于item
                    current=current.getNext()#current前进道下一个节点
        return found#返回found

    def add(self,item):#重新定义add算法，此处采用的是有序表中变量为数，按从小到大的顺序排列
        current=self.head#current为遍历无序表的变量
        previous=None#previous为current先前的值，初始值为空
        stop =False#stop为是否停止的布尔值，初始为False
        while current !=None and not stop:#若没有到表尾且不需要停下
            if current.getData()>item:#因为有序表按照从小到大排列，所以若current的值大于item，则应该在现在的previous和current之间插入item
                stop=True#将stop改为True
            else:#若还没有到插入点
                previous=current#previous前进到current
                current=current.getNext()#current前进道下一个节点
        temp=Node(item)#将item转化为一个节点temp
        if previous ==None:#若插入点为表头
            temp.setNext((self.head))#将temp的setNext连上表头之后的第一个节点
            self.head=temp#将链表的表头连到temp上
        else:#若插入点不在表头处
            temp.setNext(current)#将temp的setNext连上current
            previous.setNext(temp)#将tprevious的setNext连上temp

    append=None#有序表中不存在append操作，因此将父类无序表的append改为None
    insert=None#有序表中不存在insert操作，因此将父类无序表的insert改为None
