from  Unorderedlist import  Node#调用Unorderedlist文件中的Node类型

from Unorderedlist import UnorderedList#调用Unorderedlist文件中的Unorderedlist类型，Unorderedlist文件中保存了已经实现的所有无序表操作

class Stack(UnorderedList):#定义Stack，以链表的表头作为栈的顶端，表尾作为栈的底段
    def isEmpty(self):#定义isEmpty操作
        return (self.head==None)#若链表表头为空，则返回True，否则则返回Fals
    def push(self,item):#定义push操作
        self.add(item)#调用无序表的add操作
    def Stackpop(self):#定义Stackpop操作，即pop，为了使函数名不重复，此处写为Stackpop
        current=self.head#current为表头的节点
        self.head=current.getNext()#将head连上current指向的节点
        return  current.getData()#返回current的值
    def peek(self):#定义peek操作
        current = self.head#current为遍历无序表的变量
        if (current != None):#若表不是空表
            return current.getData()#返回current的值
        else:
            return None#若是空表，返回None
    def Stacksize(self):#定义Stacksize操作
        return self.size()#调用无序表的size操作

class Queue(UnorderedList):#定义队列Queue，以链表的表头作为队列的尾端，以表尾作为队列的首段
    def isEmpty(self):#定义isEmpty操作
        return (self.head==None)#若链表表头为空，则返回True，否则则返回Fals
    def enqueue(self,item):#定义enqueue操作
        self.add(item)#调用无序表的add操作，队列加入元素在队列尾端
    def dequeue(self):#定义dequeue操作
        return self.pop()#调用无序表的pop操作，队列取出首端的元素
    def Queuesize(self):#定义Queuesize操作
        return self.size()#调用无序表的size操作


