class Node:#重新定义Node节点
    def __init__(self,initdata):
        self.data=initdata
        self.next=None
        self.prev=None#增加Node的prev变量，即之前指向的节点
    def getData(self):
        return self.data
    def getNext(self):
        return self.next
    def getPrev(self):#增加getPrev操作，返回节点的prev
        return self.prev
    def setData(self,newdata):
        self.data=newdata
    def setNext(self,newnext):
        self.next=newnext
    def setPrev(self,newprev):#增加setPrev操作，设置节点之前指向的节点
        self.prev=newprev

class UnorderedList:#重新定义UnorderedList
    def __init__(self):
        self.tail=None#增加tail变量，即链表的末尾
        self.head=None
    def add(self,item):#重新定义add操作
        temp=Node(item)#将item转化为Node
        temp.setNext(self.head)#将temp之后指向head所指向的节点
        if self.tail==None:#若一开始为空表
            self.tail=temp#将tail连在temp上
            self.head = temp#将head连在temp上
        else:#若之前不是空表
            self.head.setPrev(temp)#将head指向的节点的prev指向temp
            self.head = temp  # 将head连在temp上

    def pop(self):#定义pop操作
        current = self.tail#取current为链表尾值
        if current.getPrev() == None:#若链表中节点数只有一个
            self.head = None#head指向None
            self.tail=None#tail指向None
        else:#若链表中节点有多个
            self.tail=current.getPrev()#tail指向current的前一个节点
            current.getPrev().setNext(None)#current前一个节点之后指向None
        return current.getData()#返回current的值
