def steelValue(treasure,maxw,maxvalue,item):   ### 偷盗函数
    for weight in range(maxw+1):              ###对于某一限定重量weight，
        valueCount = 0
        newitem = 0
        for j in [index for index in range(len(treasure)) if treasure[index]['w'] <= weight]:   ###考察前j+1件物品，
            if maxvalue[weight - treasure[j]['w']][j] + treasure[j]['v'] > valueCount:          ####如果value[weight][j] > value[weight][j-1],即拿第j+1件物品比不拿好，则拿，否则不拿
                valueCount = maxvalue[weight - treasure[j]['w']][j] + treasure[j]['v']         ###更新最大价值
                newitem = j                                                                    ###更新拿取的最后一件物品
            maxvalue[weight][j+1] = valueCount                                                ###记录特定重量和物品件数下的最大价值
        item[weight] = newitem                                                               ###记录特定重量下拿去的最后一件物品
    return maxvalue[maxw][len(treasure)]                                                    ####多次循环，返回题目给定总重量和总物品数对应的最大价值

def printItem(treasure,maxw,item):          ###显示偷盗列表的函数
    weight = maxw
    while weight >0:
        thisItem = item[weight]                ###依次显示偷到的物品
        print("No.:",thisItem,"Value:",treasure[thisItem]['v'])
        weight = weight - treasure[thisItem]['w']

def main():
    treasure = [{'w': 2, 'v': 3}, {'w': 3, 'v': 4}, {'w': 4, 'v': 8}, {'w': 5, 'v': 8}, {'w': 9, 'v': 10}]   ##物品列表
    maxw = 20                               ##重量限制
    maxvalue = [[0 for i in range (len(treasure)+1)] for j in range (maxw+1)]            ###建立最大价值列表
    item = [0]* (maxw+1)                                                                 ###建立物品列表

    print("Steeling less than",maxw,", values:")
    print(steelValue(treasure,maxw,maxvalue,item))
    print("The items and their value are:")
    printItem(treasure,maxw,item)

main()