from pythonds.basic.stack import Stack
opstack = Stack() #暂存操作符
operandstack = Stack() #暂存操作数
infixexpr=input()
tokenlist=infixexpr.split() #分割
prec = {}
prec["*"] = 3
prec["/"] = 3
prec["+"] = 2
prec["-"] = 2
prec["("] = 1 #定义运算符优先级

def domath(op,op1,op2):
    if op == "*":
        return op1*op2
    elif op == "/":
        return op1/op2
    elif op == "+":
        return op1+op2
    else:
        return op1-op2 #定义运算

for token in tokenlist:
    if token in "0123456789":
        operandstack.push(int(token))
    elif token == '(': #遇到'('就压入
        opstack.push(token)
    elif token == ')': #遇到')'就弹出
        toptoken = opstack.pop()
        while toptoken != '(':
            operand2 = operandstack.pop()
            operand1 = operandstack.pop()
            result = domath(toptoken,operand1,operand2) #对弹出的两个操作数根据操作符进行相应的运算
            operandstack.push(result)
            toptoken = opstack.pop()
    else: #比较与栈顶运算符的优先级，如果栈顶的高于或等于它，就要反复弹出栈顶操作符，加到输出列表末尾，直到栈顶的操作符优先级低于它
        while (not opstack.isEmpty()) and \
                (prec[opstack.peek()]>=prec[token]):
            toptoken = opstack.pop()
            operand2 = operandstack.pop()
            operand1 = operandstack.pop()
            result = domath(toptoken, operand1, operand2)
            operandstack.push(result)
        opstack.push(token) #计算结果压入栈顶

while not opstack.isEmpty(): #运算符依次出栈，每个运算符出栈都要和栈顶的两个数进行计算，并把结果压入栈中
    toptoken = opstack.pop()
    operand2 = operandstack.pop()
    operand1 = operandstack.pop()
    result = domath(toptoken, operand1, operand2)
    operandstack.push(result) #计算结果压入栈顶
print(int(operandstack.pop())) #计算结果在栈顶，弹出计算结果
