#定义散列表类实现ADT
class hashtable:
    def __init__(self):
        self.size=23    #散列表长度定为23
        self.slots=[[]]*self.size   #用于存储key值的slot列表
        self.data=[[]]*self.size    #用于存储数据项的data列表
    def hashfunction(self,key):
        return key%self.size    #找到散列表中的key值的位置
    #定义put方法
    def put(self,key,data):
        hashvalue=self.hashfunction(key)
    # 如果key已有，替换
        if key in self.slots[hashvalue]:
            self.data[hashvalue][self.slots[hashvalue].index(key)]=data
    # 如果key没有，加进去
        else:
            self.slots[hashvalue].append(key)
            self.data[hashvalue].append(data)
    #定义get方法
    def get(self,key):
        findslot=self.hashfunction(key)
        return self.data[findslot][self.slots[findslot].index(key)]
    #定义 del特殊方法
    def __del__(self,key):
        findslot=self.hashfunction(key)
        pos=self.slots[findslot].index(key)
        del self.slots[findslot][pos]
        del self.data[findslot][pos]    #获得key和data在所处列表中的位置并删除。
    #定义 len特殊方法
    def __len__(self):
        count=0
        for slots in self.slots:
            count+=len(slots)
        return count        #计数并返回散列表中数据个数
    #定义in特殊方法
    def __contains__(self,key):
        findslot=self.hashfunction(key)
        return (key in self.slots[findslot])