class Map():

    def __init__(self):
        self.size=11
        self.slot=[[] for i in range(self.size)]#存放key值的列表
        self.data=[[] for i in range(self.size)]#存放data的列表

    def listfunction(self,key):#求余方法实现散列函数
        return key%self.size

    def put(self,key,data):
        listvalue=self.listfunction(key)
        if self.slot[listvalue]==key:#如果key值存在，进行数值替换
            i=self.slot[listvalue].index(key)#（key值和data存在的位置在一个内层列表的同一个位置）
            self.data[listvalue][i]=data
        else:                        #不存在，在散列表相应项中增加项
            self.slot[listvalue].append(key)
            self.data[listvalue].append(data)

    def get(self,key):
        listvalue=self.listfunction(key)
        data=None
        if key in self.slot[listvalue]:
            i = self.slot[listvalue].index(key)#从key值的位置找到data的位置
            data=self.data[listvalue][i]
            return data
        else:
            return "该索引值不存在"

    def __delitem__(self, key):
        listvalue=self.listfunction(key)
        if key in self.slot[listvalue]:
            i=self.slot[listvalue].index(key)
            self.slot[listvalue].remove(key)#删除key和data
            self.data[listvalue].pop(i)
        else:
            return "该索引值不存在，不能删除"

    def __len__(self):
        c=0
        for i in self.slot:
            c+=len(i)
        return c

    def __contains__(self,key):
        c=False
        listvalue=self.listfunction(key)
        if key in self.slot[listvalue]:
            c=True
        return c

    def __getitem__(self,key):#通过特殊方法实现[]访问
        return self.get(key)

    def __setitem__(self,key,data):
        return self.put(key,data)

m=Map()
m.put(1,'cat')
m.put(20,'dog')
print(m.get(20))
print(m.slot)
print(m.data)
print(len(m))
m.__delitem__(20)
print(m.slot)
print(m.data)
print(len(m))
print(m.__contains__(1))