import turtle
import random
def yinghua(t,n):                                #这是一个画樱花的函数
    t.width(3)                           
    for i in range(5):                           #其实就是一个很小的五角星
        for j in range(10):
            y = hex(int(192-7.1*(j-4.5)**2))[2:] #但是我做了颜色渐变
            t.color('#ff' + y + y)               #所以一朵花由50段线组成，海龟跑起来比较耗时
            if j == 9:                           #为了美观，在花瓣外围有一个加宽，让它看起来不像是一个五角星
                t.width(4)
            t.forward(0.1*n)
        t.right(144)                             #因为是五角星所以转144度
        t.width(3)
        
def yingchun(t,n):                               #这个函数画的是迎春花
    t.width(4)
    t.color('#ffff00')                           #迎春花是很纯的黄色，不用做渐变
    t.forward(n)
    t.backward(2*n)                              #其实就是画了个十字
    t.forward(n)                                 #不过在二叉树上长迎春花看起来怪怪的
    t.right(90)
    t.forward(n)
    t.backward(2*n)
    t.forward(n)
    t.left(90)

def bitao(t,n):                                  #这个函数画的是碧桃花，在校园很常见
    t.width(n)                                   #简化版的效果就是两个圈，外面粉白色，里面粉红色
    t.color('#ff3030')                           #这里画的是粉红色的内圆
    t.forward(0.001)                             #向前走一小点
    t.up()
    t.forward(0.5*n-0.0005)                      #然后走到边缘
    t.down()
    t.width(n/3)
    t.color('#ffd0d0')                           #粉白色
    t.left(90)                                   #准备转圈
    t.forward(n/5.66)                            #为保证外圈与内圈基本上是同心圆，需要先移动半个边长
    for i in range(7):                           #然后开始转圈
        t.left(45)
        t.forward(n/2.83)
    t.left(45)
    t.forward(n/5.66)                            #最后把这半个边长移回来
    t.left(90)                                   #画完了
    t.up()
    t.forward(0.5*n+0.0005)                      #接下来要归位继续画树
    t.down()
    t.left(180)
 
def huaji(t,n):                                  #这个函数画的是滑稽果，，，，，
    t1 = turtle.Turtle()                         #相当的麻烦，需要先创建一个海龟
    t1.up()
    t1.setpos(t.position())                      #让它到达当前的海龟的位置
    t1.color('#eecc00')                          #黄色的滑稽
    t1.begin_fill()
    t1.fillcolor('#eecc00')                      #准备填充
    t1.down()
    for i in range (20):                         #画一个圆
        t1.forward(0.314*n)
        t1.right(18)
    t1.end_fill()                                #填充为滑稽黄
    t1.right(140)                                #移动海龟，开始画眼睛
    t1.forward(n)
    t1.left(170)
    t1.width(0.1*n)
    t1.color('#ffffff')                          #先画一点白的
    t1.forward(0.095*n)
    t1.color('#a52a2a')                          #然后再画一点棕色
    t1.right(7.5)
    t1.width(0.11*n)                             #不过要转一个小角度
    t1.forward(0.095*n)                          #棕色画好了
    t1.color('#ffffff')                          #再次改成白色
    t1.right(7.5)                                #为了保证眼睛的完整性，要将海龟提起来前移一小段
    t1.up()
    t1.forward(0.095*n)
    t1.down()
    for i in range(6):                           #再将剩余的眼白部分画完
        t1.right(7.5)
        t1.width((0.15-abs(3-i)*0.01)*n)         #滑稽的眼白比较宽，在这里宽度做了个渐变
        t1.forward(0.095*n)
    t1.left(30)                                  #准备画另一只眼睛
    t1.up()
    t1.forward(0.3*n)                            #那么首先要越过“鼻梁”
    t1.down()
    t1.left(30)                                  #越过鼻梁了
    t1.width(0.1*n)
    t1.forward(0.095*n)                          #这部分跟上一只眼睛完全相同
    t1.color('#a52a2a')
    t1.right(7.5)
    t1.width(0.11*n)
    t1.forward(0.095*n)
    t1.color('#ffffff')
    t1.right(7.5)
    t1.up()
    t1.forward(0.095*n)
    t1.down()
    for i in range(6):
        t1.right(7.5)
        t1.width((0.15-abs(3-i)*0.01)*n)
        t1.forward(0.095*n)
    t1.right(60)                                 #两只眼睛都画完了
    t1.up()
    t1.forward(0.45*n)                           #调整一下海龟的位置，准备画嘴
    t1.right(100)
    t1.forward(0.18*n)
    t1.left(90)
    t1.width(0.05*n)
    t1.down()                                    #位置调整完毕
    t1.color('#a52a2a')                          #用棕色画嘴
    for i in range (10):                         #嘴巴其实就是一个半圆
        t1.forward(0.25*n)
        t1.right(18)
    t1.up()
    t1.left(10)                                  #画完嘴以后感觉还缺了什么，思考了了好久最后补上了眉毛
    t1.forward(0.8*n)                            #老规矩画眉毛之前调整海龟的位置
    t1.right(45)
    t1.forward(0.2*n)
    t1.color('#000000')                          #然后用黑色来画
    t1.down()
    for i in range(9):                           #眉毛也可以看做一个小弧线
        t1.right(15)
        t1.forward(0.05*n)
    t1.up()                                      #一个眉毛画完以后，开始调整位置
    t1.left(90)
    t1.forward(0.7*n)
    t1.left(90)
    t1.down()
    for i in range(9):                           #再画另一个眉毛
        t1.forward(0.05*n)
        t1.right(15)                             #终于画完了
    t1.hideturtle()                              #过河拆桥，把画滑稽的功臣隐藏起来（滑稽函数写了80行程序，比树长两倍多。。。）
    
def tree(t,m,n):                                 #这是那个画树的函数，t是turtle，m是枝干长度，n是迭代次数，即树杈级别
    if m>10:
        if m < 30:                               #在枝干足够短的时候可以画花了
            if random.randint(0,50)>35:          #不是每一个枝节里都能长花，但是长花的量大致上是可调的
                yinghua(t,n+4)                  #一般情况下只长一种花，所以把其他的花备注掉，这里是樱花（再强调一遍，更改这里的备注对象可以改变树上长的花的种类~~~~~~，现在默认是樱花~~~~）
                #yingchun(t,5+0.5*n)             #这里是迎春花
                #bitao(t,1.5*n)                  #这里是碧桃花
                #if random.randint(0,50)>35:      #这里是滑稽果，滑稽果型号较大，需要减少数量
                #    huaji(t,2*n)                 #滑稽树上滑稽果，滑稽树下你和我
        w = 10824234                             #枝干的颜色也要做渐变，从棕色过渡到绿色
        q = hex(w-1175812*n-2*n//3)[2:]
        while len(q) < 6:                        #但是纯绿色的时候红色就没了，要给颜色补零
            q = '0' + q
        t.color('#' + q)
        t.width(19-2*n)                          #调整枝条宽度
        t.forward(m)                             #然后开始画枝条了
        if m<30 and m>12.1 and random.randint(0,50)>65-5*n: #二叉树感觉还是不够枝繁叶茂，所以我设计在枝条比较短而且并非最后一级枝条的情况下，
                                                            #让它在这级枝条画完后，延伸出第三条腿
                                                            #和花一样，第三条腿也不是每个枝节都有，但是越到末节，有的概率越大
                t.width(17-2*n)                  #第三条腿和下一级枝条同级，所以宽度要降低，但颜色不发生改变
                b = random.randint(0,50)         #角度可以与之前相比发生变化
                t.right(b)
                t.forward(m/(1.53-0.04*n))       #画出“第三条腿”
                t.backward(m/(1.53-0.04*n))      #画完了
                t.left(b)
        a = random.randint(15,30+n)              #回来接着画树
        b = random.randint(15,30+n)              #用ab存储转过的和将要转的角度
        t.right(a)
        tree(t,m/(1.53-0.04*n),n+1)              #然后用递归，枝条长度采用指数级下降，而且指数随迭代次数下降，在一开始下降快，后来下降慢，也是为了看起来枝繁叶茂
        t.left((a+b))                            #然后这两行没什么区别
        tree(t,m/(1.53-0.04*n),n+1)
        #t.left(0.5*(a+b))                       #本来想画三叉树，但是画三叉树的用时会变为二叉树的60倍，而且过于枝繁叶茂，所以放弃了
        #tree(t,m/(1.53-0.04*n),n+1)
        t.right(b)
        t.up()
        t.backward(m)
        t.down()                                 #剩下的基本都是标准画树递归
        
t = turtle.Turtle()
w = turtle.Screen()
w.tracer(0)                                      #用tracer记录，要不然真的好慢
t.left (90)
t.up()
t.backward(300)                                  #预先向下移动 
t.down()
tree(t,190,0)                                    #190与上面的1.53配合刚好可以做10级枝条分支
w.update()
w.exitonclick()
