import turtle
#turtle.tracer(0)这里可以设置暴走，用于阶数较多时，如果阶数为1或2，使用暴走，会画不出图形
def draw_Hilbert(Level,Index):
    if Level>0:
        for i,j in enumerate(draw_index[Index]):
            draw_Hilbert(Level-1,j)#调用draw_Hilbert()函数自身
            moves(move_index[Index][i][0],move_index[Index][i][1])

def moves(dx,dy):
    global x,y#使用global语句指定多个全局变量
    x += dx
    y += dy
    turtle.goto(x,y)
#turtle.update()
x ,y,h= 0,0,10#设定起始位置，可以更改
turtle.penup()
turtle.goto(x, y)
turtle.pendown()#为了不留下起点移动的痕迹，使用penup、pendown
draw_index={'a':'daab','b':'cbba','c':'bccd','d':'addc'}#新建draw_index和move_index两个字典类型，分别记录不同节点时的绘图次序和绘图方向
move_index={'a':[[-h,0],[0,h],[h,0],[0,0]],'b':[[0,-h],[h,0],[0,h],[0,0]],'c':[[h,0],[0,-h],[-h,0],[0,0]],'d':[[0,h],[-h,0],[0,-h],[0,0]]}
draw_Hilbert(4,'a')#设定阶数为4，并且可以在此处调整阶数

