import turtle                       #希尔伯特曲线
def huaxian(t,n,m):                 #定义一个画线函数，参数为海龟t，曲线阶数n，正反画记录m
    if n > 0 and n%2 == 0:          #阶数为偶数的情况下
        t.right(90+180*m)           #m为0时正画（开始在左，结束在右），为一时反画（开始在右，结束在左）
        huaxian(t,n-1,int(not m))   #递归，正反序颠倒
        t.right(90+180*m)           #所有转向在正反画时均完全相反
        t.forward(20)               #整体线路（左右转）基本按照希尔伯特曲线上的图示完成
        huaxian(t,n-1,m)            #每个n阶的希尔伯特曲线均由4个n-1阶的曲线组成
        t.left(90+180*m)            #因此一共要写4个递归，中间的内容为连接部分
        t.forward(20)
        t.left(90+180*m)
        huaxian(t,n-1,m)
        t.forward(20)
        t.right(90+180*m)
        huaxian(t,n-1,int(not m))
    elif n%2==1 and n>0:            #n为奇数的情况
        t.right(90+180*m)           #在转向调整上与偶数情况不同
        huaxian(t,n-1,int(not m))   #但是基本原理完全相同
        t.forward(20)
        huaxian(t,n-1,m)
        t.forward(20)
        t.left(90+180*m)
        huaxian(t,n-1,m)
        t.right(90+180*m)
        t.forward(20)
        t.right(90+180*m)
        huaxian(t,n-1,int(not m))
    else:                           #0阶希尔伯特曲线只有一个点，但是程序设置中规定偶数阶希尔伯特曲线自带右转效果
        t.right(90+180*m)           #所以只好给这里的零阶希尔伯特曲线加一个右转
t = turtle.Turtle()
w = turtle.Screen()
t.speed(0)
t.up()                              #预先移动是因为我要画一个巨大的5阶希尔伯特曲线
t.backward(300)
t.left(90)
t.backward(305)
t.down()
huaxian(t,5,0)                      #画出来的曲线基本填满整个窗口（强迫症福利！）
w.exitonclick()
