import turtle
n = int(input())
myWin = turtle.Screen()
l = 700
x = l / (2 ** n + 1)
#使得每一笔画的长度随着阶数n的增大而减小
def hilbert(n,m,x,t):
#参数说明：n：阶数，m：顺逆时针标记，x：每一笔画长度，t：海龟
    if n == 1:
        t.forward(x)
        t.right(180 * m + 90)
        t.forward(x)
        t.right(180 * m + 90)
        t.forward(x)
        #n=1，很简单的基本结构
    else:
        t.right(180 * m + 90)
        hilbert(n - 1, 1 - m,x,t)
        #n-1：阶数降1减小问题规模，1-m：表示顺逆时针对调
        t.right(180 * m + 90)
        t.forward(x)
        hilbert(n - 1, m,x,t)
        t.left(180 * m + 90)
        t.forward(x)
        t.left(180 * m + 90)
        hilbert(n - 1, m,x,t)
        t.forward(x)
        t.right(180 * m + 90)
        hilbert(n - 1, 1 - m,x,t)
        t.right(180 * m + 90)
        #至于tleft和tright的操作，通过1阶->2阶的推导，就可以得到规律
        #同时变量m保证了对顺时针和逆时针的对应关系
def main():
    t = turtle.Turtle()
    #通过海龟作图实现
    w = turtle.Screen()
    turtle.tracer(0)
    #海龟暴走
    t.penup()
    t.backward(350)
    t.left(90)
    t.backward(350)
    t.pendown()
    #设定海龟初始位置，位于图片的左下
    hilbert(n,0,x,t)
    turtle.update()
    w.exitonclick()

main()