import turtle

#使用海龟画图实现输出杨辉三角
n = int(input())

global line
#使用全局变量列表line
line = [1]
def printTri(n):
    global line
    if n == 1:
        t.write('1',align='center')
        #当n=1 相当简单
        #我们在‘center’位置输出每一行，这样就是等腰三角形了
        t.forward(25)
        #到下一行
    else:
        printTri(n-1)
        #递归减小问题规模
        line = [sum(i) for i in zip([0]+line, line+[0])]
        #错位相加得到杨辉三角形的下一行
        lineoutput = map(str, line)
        output = ' '.join(lineoutput)
        #将列表合并为待输出的字符串
        t.write(output, align='center')
        t.forward(25)

t = turtle.Turtle()
w = turtle.Screen()
t.right(90)
#让海龟的头转向下方，实现从上到下输出
t.up()
#不让海龟留下踪迹！
t.back(300)
#现在海龟已经调好位置
printTri(n)
w.exitonclick()