def dadao(vl,wl,m):               #博物馆大盗，传入参数价值表，重量表，背包容量m
    n = len(vl)                   #记录物品个数
    x = [0]                       #在包裹容量为零时，只能拿价值为零的物品，记录这个解
    s = (1,)                      #用一个元组来存储在第i个解中的各物品被拿的情况
    for i in range(n-1):          #那么这个元组的长度应该和物品个数相同
        s += (1,)
    fl = ()                       #fl是一个用来存储这样的元组的元组，使用元组是为了使其内容在设定后不被修改
    fl += (s,)
    p = 0                         #p,q是两个计数器，其作用在后面会提到，但是但是在这里需要预先定义
    q = 0
    for i in range(1,m+1):        #i从1循环到背包容量m
        x += [x[i-1]]             #背包容量+1，那么至少能放下原先背包里装的东西，这是其中一个解
        for j in range(n):        #然后遍历背包中的其他物体
            if i >= wl[j]:        
                if fl[i-wl[j]][j] == 1 and x[i] < x[i-wl[j]]+vl[j]: #如果发现这个物体不在背包里，背包的一个最优解在容量增加后能够装下这个物体，而且装下之后的价值超过了原先的最优解
                    x[i] = x[i-wl[j]]+vl[j]             #那就把它装进去好了
                    p = i         #计数器告诉我们这一轮有新装进去的东西
                    q = j         #这个新装进去的东西的编号是q
        if p == i:                #接下来要利用计数器看一下是不是有新装进去的东西
            r = fl[i-wl[q]]       #如果有，就要利用原先的最优解的物品被拿情况更改一下新的物品被拿情况
            s = ()                #所以要再建立一个元组
            for t in range(n):    #除了被拿走的物品状态是0以外，其他物品都与前一组最优解的物品情况相同
                if t != q:
                    s += (r[t],)
                else:
                    s += (0,)
            fl +=(s,)
        else:                     #如果没有新装进去的东西
            r = fl[i-1]           #那么物品的拿放情况与背包容量+1之前相同
            fl += (r,)
        print(str(i)+' '+str(x[i])+str(fl[i]))  #最后把背包容量为i的情况下的最优解以及此时每件物品的拿放情况输出一下
    return x[m]                   #返回值为背包容量为m时的最优解
        

        
vl = [3,4,8,8,10]                 #传入的两个列表直接写在程序里了
wl = [2,3,4,5,9]
print(str(dadao(vl,wl,20)))       #输出
