def dancibianhuan(s1,s2):            #单词变换函数
    m = len(s1)                      #先得到两个字符串的长度
    n = len(s2)
    x = []                           #用一个3阶的列表储存结果，为m行，n列，每个点储存2条信息
    for i in range(m+1):             #做一个二重循环，外重循环为第一个字符串的各个字母
        x += [[]]                    #i每加一，都要给储存用的三阶列表加一行
        for j in range(n+1):         #内重循环，对第二个字符串
            t = []                   #t储存的是最优解的情况
            t +=[i+j]                #对i或j为零的情况，可能得到的解不全，需要加一个最大的解，即此时两字符串长度之和
            if i != 0:               #如果i不为零，即第一个字符串不空
                p = x[i-1][j][0]+1   #就可以尝试删除的情况
                t += [p]
                if j != 0:           #如果在此情况下第二个字符串也不空
                    r = x[i-1][j-1][0] + 2*int(s1[i-1]!=s2[j-1]) #那么既可以尝试复制
                    t += [r]
                    q = x[i][j-1][0]+1 #又可以尝试插入
                    t += [q]         #将三种情况的结果都存起来
            elif j!= 0:              #还要补上一种第一个字符串空的二个不空的情况
                q = x[i][j-1][0]+1   #这种情况也是插入
                t += [q]
            x[i] += [[min(t),t.index(min(t))]] #每个点存两条信息，一个是最小操作距离，一个是这个最小操作距离的操作，如果是1则对应p（删除），2则对应r（复制），3则对应q（插入）
    return x 

def caozuo(a,b,x):                   #开始操作了（见证奇迹的时刻！）
    m = len(a)                       #记录两字符串长度
    n = len(b)
    y = x[m][n][0]                   #现将最短操作距离存储下来作为返回值，然后将要改变m,n的值
    while m+n >0:                    #在从最后一个点返回到第一个点的过程中
        if x[m][n][1] == 0:          #如果发现已经没有什么共同的了（即最优解与操作最多的解相同）
            if m > 0:                #那么先删除或是先插入就没什么意义了，随便来吧，这个函数里写的是先删除
                t = 1                #t = 1 为删除的情况记录
            else:
                t = 3                #t = 3 为插入的情况记录
        else:                        #发现最优解与最差解不同，那么就需要看看这个解是怎么来的
            t = x[m][n][1]           #在单词变换函数中已经记录了数字与操作的对应
        if t == 1:                  
            m -= 1                   #删除操作
            print('删除 '+a[m])
        elif t == 2:
            m -= 1
            n -= 1                   #复制操作
            print('复制 '+a[m])
        else:
            n -= 1                   #插入操作
            print('插入 '+b[n])
    return y                         #但是发现这样输出的结果是反着的

def fan (a):                         #于是干脆把字符串反过来
    m = len(a)
    t = ''
    for i in range(m):               #想要做到这一点还是比较简单的
        t += a[m-i-1]
    return t

a = 'intention'                      #再一次把输入直接写到程序里去了
b = 'execution' 
print('单词 '+ a + ' ' + b)          #先把单次输出一遍
print('操作过程为：')                 
a = fan(a)                           #然后把单词反过来进行操作
b = fan(b)
x = dancibianhuan(a,b)
t = caozuo (a,b,x)
print('最小操作距离为： ',t)         #得到最小操作距离和得分
print('得分为： ',int(2.5*(len(a)+len(b)-t)+20*t))

