def thief_in_museum( max, w, v):#max表示背包的总容量，w表示物品重量的列表，v表示物品价值的列表
    n=len(w)#n表示可供偷取的物品总数，
    res = [[0 for j in range(max + 1)] for i in range(n + 1)]#先将所有的结果值全部赋值为0
    for i in range(1, n + 1):#动态规划的过程包括重量的递增与可供偷取的物品的递增
        for j in range(1, max + 1):#在限定可供偷取的个数为i-1的情况下，将重量从1递增到max值
            res[i][j] = res[i - 1][j]#回溯上一行中少了一个可供偷窃的物品的情况
            if j >= w[i - 1] and res[i][j] < res[i - 1][j - w[i - 1]] + v[i - 1]:#假如容量j比新增的这个物品的质量要大，且j里面留出给新增物品的空间后所得到的新的总价值要高于不包括这个物品时的价值
                res[i][j] = res[i - 1][j - w[i - 1]] + v[i - 1]#结果的替换
    print('今天收获真不小，偷到:', res[n][max])#真正的答案其实是这个列表的最后一个数据
    #以下的步骤主要是为了还原出到底偷了那些东西(筛选偷走的东西的算法来自于百度百科，因为很好，所以不打算采用列表记录法而借用百度的方法)
    itemlist = [False for i in range(n)]#先假设一个都没有偷走
    j = max
    for i in range(n, 0,-1):
        if res[i][j] > res[i - 1][j]:#如果没偷走这个东西时的总价值要低于偷走时的价值，那么这个东西一定是被偷走了
            itemlist[i - 1] = True#给被偷走的东西打上标记
            j =j- w[i - 1]
    for i in range(n):
        if itemlist[i]==True:
            print('我就是要偷第',i, '个，你拿我咋的 ')


#函数的主要执行部分
w = [2, 3, 4, 5, 9]
v = [3, 4, 8, 8, 10]
max = 20
thief_in_museum( max, w, v)


