object = [0, {"weigh": 2, "value": 3},{"weigh": 3, "value": 4},{"weigh": 4, "value": 8},{"weigh": 5, "value": 8},{"weigh": 9, "value": 10}]
#将第一项设为0 是为了让宝物编号和索引相同
def stealsomething(t, bag):#t为物品清单 bag为背包最大承重
    num = len(t) - 1
    choice = [[0 for i in range(num + 1)] for j in range(bag + 1)]#初始化choice[i][j]，i为个数j为重量
    Useit = [[False for p in range(num + 1)] for q in range(bag + 1)]#用于记录偷到的东西的列表，p为个数q为重量
    for i in range(1, num + 1):#i为当前可放入的物品个数
        for j in range(1, bag + 1):#j为背包给出的可用容量
            if i > 1:
                if object[i]["weigh"] > j:#可用容量放不下第i个物品
                    choice[j][i] = choice[j][i-1]#和允许放i-1个物品结果相同
                else:
                    choice[j][i] = max(choice[j - object[i]["weigh"]][i-1] + object[i]["value"], choice[j][i-1])#放入第i个的最好选择和不放入第i个的最好选择作对比
                    if choice[j - object[i]["weigh"]][i-1] + object[i]["value"] > choice[j][i-1]:#若需要放入第i个，则记录
                        Useit[j][i] = True
            else:
                if object[i]["weigh"] > j:#可用容量放不下第一个物品
                    choice[j][i] = 0#什么都不能放 value为0
                else:
                    choice[j][1] = object[1]["value"]#放进第一个
                    Useit[j][1] = True#在此情况下，使用了第i个物品
    print("最多能偷：%d"%choice[bag][num])
    w = bag
    for i in range(num, 0, -1):#从后往前开始一个个循环
        if Useit[w][i]:
            print("偷第%d个，价值：%d"% (i,object[i]["value"]))
            w = w - object[i]['weigh']
stealsomething(object, 20)