
def shortestlen(s1,s2):#定义函数名

    l1=len(s1)
    l2=len(s2)#得到字符串长度
    wordprocessing=[[0 for j in range(l2+1)] for i in range(l1+1)]#这个列表主要用于储存最短编辑距离
    processing=[[None for j in range(l2+1)] for i in range(l1+1)]#这个列表用于储存操作过程


    for i in range(1,l1+1):
        wordprocessing[i][0]=20*i
        processing[i][0]="delete"#初始化列表，使得当l2=0的时候，s1执行的操作均为delete
    for j in range(1,l2+1):
        wordprocessing[0][j]=20*j
        processing[0][j]="append"#初始化列表，使得l1=0的时候，s2执行的操作均为append


    for i in range(1,l1+1):#动态规划的主要程序
        for j in range(1,l2+1):
            if s1[i-1]==s2[j-1] and wordprocessing[i-1][j-1]+5<=wordprocessing[i][j-1]+20 and wordprocessing[i-1][j-1]+5<=wordprocessing[i-1][j]+20:#当s1,s2的某位置的字母相同时，执行复制操作，并将复制操作对应于向左上方挪动列表单元
                wordprocessing[i][j]=wordprocessing[i-1][j-1]+5
                processing[i][j]="copy"#在另一个储存列表中记录下当前的操作
            elif wordprocessing[i][j-1]+20<=wordprocessing[i-1][j]+20:#当添加字母的操作优于删除时，执行添加字母
                wordprocessing[i][j] = wordprocessing[i][j - 1] + 20
                processing[i][j]="append"
            else:
                wordprocessing[i][j] = wordprocessing[i-1][j] + 20#同上
                processing[i][j]="delete"
    print("最短编辑距离是%d"%wordprocessing[l1][l2])#得到最终的结果
    alst=[]#用于记录到底对这个字符串进行了什么操作
    while l2>0:#穷举当l2长度不断缩小时对应的情况
        if processing[l1][l2]=="copy":#三种字符串对应的方法各自不同
            alst.append("copy")
            l1-=1
            l2-=1
        elif processing[l1][l2]=="delete":
            alst.append("delete")
            l1-=1
        else:
            alst.append("append")
            l2-=1
    while l1>0:#当进行到l2已经拼凑出来时，对s1剩下的所有字母进行删除
        alst.append("delete")
        l1-=1
    for i in range(len(alst)-1,-1,-1):
        print(alst[i])#因为这是反演的过程，因此需要将整个操作步骤反过来输出


#主函数
s1="algorithm"
s2="alligator"
shortestlen(s1,s2)






