import random
from time import clock
#课件中切片方法
def binarySearch(alist,item):
    if len(alist)==0:
        return False
    else:
        midpoint=len(alist)//2
        if alist[midpoint]==item:
            return True
        else:
            if item<alist[midpoint]:
                return binarySearch(alist[:midpoint],item)
            else:
                return binarySearch(alist[midpoint+1:],item)
#不切片方法
def binarySearch2(alist,first,last,item):
    if first>last:
        return False#结束条件
    else:
        midpoint=(first+last)//2#取中位
        if alist[midpoint]==item:
            return True#找到
        else:
            if item<alist[midpoint]:
                last=midpoint-1
            else:
                first=midpoint+1#两种情况，通过改变first或last进行二分
            return binarySearch2(alist,first,last,item)#递归调用
#计时试验
for k in range(20):
    alist = [random.randint(j, j + 10) for j in range(0, 10000001, 10)]#随机生成百万级有序表
    item=random.randrange(10000000)#随机生成item
    # 切片方法计时
    start = clock()
    for i in range(100):
        binarySearch(alist,item)
    finish = clock()
    t1=(finish - start) / 100
    # 非切片方法计时
    start = clock()
    for i in range(100):
        binarySearch2(alist, 0, len(alist) - 1, item)
    finish = clock()
    t2 = (finish - start) / 100
    #输出时间
    print("%d %5f %5f" % (item, t1, t2))