import turtle

#这个曲线是自己想出来的, 暴力列出来了四种方向的曲线, 用Curve_type描述
#里面的具体关系是通过手画曲线得出来的
#后来借鉴了网上的方法, 将四种方向统一了起来(见HilberCurve2.py)

def HilbertCurve(n, t, center_position, size, Curve_type):
    #center_position接受一个坐标参数
    #size表示曲线所在的正方形的边长
    if n == 1:
        r = center_position[0] / 600 + 0.5
        b = center_position[1] / 600 + 0.5
        g = r * b
        t.color(r, g, b)
        if Curve_type == 1:
            t.down()
            if t.pos() == (0, 0):
                t.up()
            t.goto(center_position[0] - size / 4, center_position[1] - size / 4)
            t.down()
            t.goto(center_position[0] + size / 4, center_position[1] - size / 4)
            t.goto(center_position[0] + size / 4, center_position[1] + size / 4)
            t.goto(center_position[0] - size / 4, center_position[1] + size / 4)
            t.up()
        elif Curve_type == 2:
            t.down()
            if t.pos() == (0, 0):
                t.up()
            t.goto(center_position[0] - size / 4, center_position[1] - size / 4)
            t.down()
            t.goto(center_position[0] - size / 4, center_position[1] + size / 4)
            t.goto(center_position[0] + size / 4, center_position[1] + size / 4)
            t.goto(center_position[0] + size / 4, center_position[1] - size / 4)
            t.up()
        elif Curve_type == 3:
            t.down()
            if t.pos() == (0, 0):
                t.up()
            t.goto(center_position[0] + size / 4, center_position[1] + size / 4)
            t.down()
            t.goto(center_position[0] - size / 4, center_position[1] + size / 4)
            t.goto(center_position[0] - size / 4, center_position[1] - size / 4)
            t.goto(center_position[0] + size / 4, center_position[1] - size / 4)
            t.up()
        else:
            t.down()
            if t.pos() == (0, 0):
                t.up()
            t.goto(center_position[0] + size / 4, center_position[1] + size / 4)
            t.down()
            t.goto(center_position[0] + size / 4, center_position[1] - size / 4)
            t.goto(center_position[0] - size / 4, center_position[1] - size / 4)
            t.goto(center_position[0] - size / 4, center_position[1] + size / 4)
            t.up()

    else:
        if Curve_type == 1:
            HilbertCurve(n - 1, t, (center_position[0] -  size / 4 , center_position[1] -  size / 4), size / 2, 2)
            HilbertCurve(n - 1, t, (center_position[0] +  size / 4 , center_position[1] -  size / 4), size / 2, 1)
            HilbertCurve(n - 1, t, (center_position[0] +  size / 4 , center_position[1] +  size / 4), size / 2, 1)
            HilbertCurve(n - 1, t, (center_position[0] -  size / 4 , center_position[1] +  size / 4), size / 2, 4)
        elif Curve_type == 2:
            HilbertCurve(n - 1, t, (center_position[0] -  size / 4 , center_position[1] -  size / 4), size / 2, 1)
            HilbertCurve(n - 1, t, (center_position[0] -  size / 4 , center_position[1] +  size / 4), size / 2, 2)
            HilbertCurve(n - 1, t, (center_position[0] +  size / 4 , center_position[1] +  size / 4), size / 2, 2)
            HilbertCurve(n - 1, t, (center_position[0] +  size / 4 , center_position[1] -  size / 4), size / 2, 3)
        elif Curve_type == 3:
            HilbertCurve(n - 1, t, (center_position[0] +  size / 4 , center_position[1] +  size / 4), size / 2, 4)
            HilbertCurve(n - 1, t, (center_position[0] -  size / 4 , center_position[1] +  size / 4), size / 2, 3)
            HilbertCurve(n - 1, t, (center_position[0] -  size / 4 , center_position[1] -  size / 4), size / 2, 3)
            HilbertCurve(n - 1, t, (center_position[0] +  size / 4 , center_position[1] -  size / 4), size / 2, 2)
        else:
            HilbertCurve(n - 1, t, (center_position[0] +  size / 4 , center_position[1] +  size / 4), size / 2, 3)
            HilbertCurve(n - 1, t, (center_position[0] +  size / 4 , center_position[1] -  size / 4), size / 2, 4)
            HilbertCurve(n - 1, t, (center_position[0] -  size / 4 , center_position[1] -  size / 4), size / 2, 4)
            HilbertCurve(n - 1, t, (center_position[0] -  size / 4 , center_position[1] +  size / 4), size / 2, 1)
      
def main(n):
    t = turtle.Turtle()
    t.hideturtle()
    myWin = turtle.Screen()
    turtle.tracer(0)
    HilbertCurve(n, t, (0, 0), 600, 2)
    turtle.update()
    myWin.exitonclick()

if __name__ == '__main__':
    main(8)































# count = 0
# def moveto(x,y):
#     turtle.penup()
#     turtle.goto(x,y)
#     turtle.pendown()
# def hilbert(x0, y0, xi, xk, yi, yk, n):
#     if n <= 0:
#         X = x0 + (xi + yi)/2
#         Y = y0 + (xk + yk)/2
#         X2 = X * 600 -300
#         Y2 = Y * 600 -300
#         global count
#         if count < 1:
#           count = count + 1
#           moveto(X2,Y2)
#         turtle.color(X,Y,X*Y)
#         turtle.goto(X2,Y2)
#     else:
#         hilbert(x0,               y0,               yi/2, yk/2, xi/2, xk/2, n - 1)
#         hilbert(x0 + xi/2,        y0 + xk/2,        xi/2, xk/2, yi/2, yk/2, n - 1)
#         hilbert(x0 + xi/2 + yi/2, y0 + xk/2 + yk/2, xi/2, xk/2, yi/2, yk/2, n - 1)
#         hilbert(x0 + xi/2 + yi,   y0 + xk/2 + yk,  -yi/2,-yk/2,-xi/2,-xk/2, n - 1)

# def main():
#     turtle.colormode(1.)
#     turtle.speed(0)
#     for depth in range(9):
#       if depth > 3:     # for faster rendering.
#         turtle.getscreen().tracer(0)
#       global count
#       count = 0
#       hilbert(0.0, 0.0, 1.0, 0.0, 0.0, 1.0, depth)
#       turtle.getscreen().tracer(1)
#     turtle.Screen().exitonclick()

# if __name__ == "__main__":
#     main()
