import turtle

#T_len表示等边三角形的边长
def draw_PT(n, t, T_len):
    for j in range(n+1):
        t.goto(-T_len * j/2 , 300 - 1.732 *j *T_len/2)
        for i in PascalTriangle(j):
            t.write(i, font=('Arial', 12, 'normal'))
            t.forward(T_len)

#用递归和zip函数来实现
def PascalTriangle(n):
    if n == 0:
        return [1]
    else:
        return [sum(i) for i in zip(PascalTriangle(n-1)+[0], [0]+PascalTriangle(n-1))]
    
def main():
    t = turtle.Turtle()
    t.up()
    t.hideturtle()
    myWin = turtle.Screen()

    draw_PT(12, t, 60)

    myWin.exitonclick()

if __name__ == '__main__':
    main()