#!/usr/bin/env python
# -*- coding:gbk -*-
""" ʵ֣
1. ʵUnorderedlistڲʵappend, index, pop, insert
תΪַ__str__Ƭ__getitem__
popinsertΪgetitemΪ򲽳stepƬ
2. ̳UnorderedlistʵOrderedList޸˸add, search"""
# ࣺڵ
class Node:
	def __init__(self, initdata):
		self.data = initdata
		self.Next = None
	def getData(self):
		return self.data
	def getNext(self):
		return self.Next
	def setData(self, newdata):
		self.data = newdata
	def setNext(self, newNext):
		self.Next = newNext
# ࣺ
class UnorderedList:
	# ʼ
	def __init__(self):
		self.head = None
	#addӽڵڿͷ
	def add(self, item):
		temp = Node(item)
		temp.setNext(self.head)
		self.head = temp
	#Ԫزʵ֡
	def search(self, item):
		pCurrent = self.head
		flag = False
		while pCurrent != None:
			if pCurrent.getData()==item:
				flag = True
				break
			pCurrent = pCurrent.Next
		return flag
	#巵شС
	def size(self):
		pCurrent = self.head
		count = 0
		while pCurrent != None:
			count += 1
			pCurrent = pCurrent.Next
		return count
	#尴ɾԪز
	def remove(self, item):
		#ʹpNextָҪɾȥĽڵ
		pNext = self.head
		pPrev = None
		while pNext != None:
			if pNext.getData() == item:
				break
			else:
				pPrev = pNext
				pNext = pNext.getNext()
		#һڵҪɾȥǰΪգheadԭڶ·pNext
		if pPrev == None:
			self.head = pNext.getNext()
		else:
			pPrev.setNext(pNext.getNext())
	#壺ݷֵ
	def index(self, item):
		#ͬʱּ
		pCurrent = self.head
		count = 0
		while pCurrent != None:
			#ҵݣشʱֵΪֵ
			if pCurrent.getData()==item:
				return count
			count += 1
			pCurrent = pCurrent.Next
		#򣬷ءҲ
		return 'Not Found'
	#壺appendӽڵ
	def append(self, item):
		Nodetemp = Node(item)
		pCurrent = self.head
		#Ϊգֱhead
		if pCurrent == None:
			self.head = Nodetemp
		#򣬱һڵ㣬ýڵNextָ½ڵ
		else:
			while pCurrent.Next != None:
				pCurrent = pCurrent.Next
			pCurrent.setNext(Nodetemp)
	#壺posλòڵ㣬һΪλãڶΪڵ
	def insert(self, pos, item):
		s1 = self.size()
		if pos<0:
			pos = pos + s1
		if pos<=0:
			self.add(item)
		elif s1<=pos:
			self.append(item)
		else:
			newNode = Node(item)
			pCurrent = self.head
			count = 0
			while count!=pos:
				count += 1
				pPrevious = pCurrent
				pCurrent = pCurrent.getNext()
			pPrevious.setNext(newNode)
			newNode.setNext(pCurrent)
		return 'Done'
	#壺popɾΪȱʡֵ-1
	def pop(self, index=-1):
		if self.size()==0:
			return 'Unable to Pop:Empty Unordered List'
		else:
			#ΪתΪתȻΪ򷵻޷ҵλ
			if index<0:
				index = self.size()+index
				if index<0:
					return 'Unable to Pop:Position Not Found'
			#ּ
			pCurrent = self.head
			pPrev = None
			count = 0
			while pCurrent.Next!= None:
				#жϱ
				#pCurrentָλɾڵ㣬pPrevָǰڵ
				if count == index:
					break
				count += 1
				pPrev = pCurrent
				pCurrent = pCurrent.Next
			#ռޣ򣬼¼pCurrentݣɾýڵ
			if count<index:
				return 'Unable to Pop:Position Not Found'
			else:
				out = pCurrent.getData()
				#Ϊ׽ڵ㣬headֱָڶǰNext·pCurrent
				if pPrev == None:
					self.head = pCurrent.Next
				else:
					pPrev.setNext(pCurrent.Next)
			#pCurrent
			return out
	#壺ƬkeyΪͻslice
	def __getitem__(self, key):
		#ΪͣΪתΪֵҵԪأ
		outlist = UnorderedList()
		if isinstance(key, int):
			if key<0:
				key = key+self.size()
			if key<0:
				return outlist
			pCurrent = self.head
			count = 0
			while pCurrent!=None:
				if count == key:
					out = pCurrent.getData()
					return out
				else:
					count += 1
					pCurrent = pCurrent.getNext()
			else:
				return outlist
		#ΪslicesliceԪظ
		elif isinstance(key, slice):
			pCurrent = self.head
			count = 0
			smax = self.size()
			#ʼסββΪֵתΪֵ
			Start, Stop, Step = key.start, key.stop, key.step
			if Start<0:
				Start = smax+Start
			if Stop<0:
				Stop = smax+Stop
			#βԴڸֵֵ޻ֵβֵЧб
			if Start<0 or Start>=smax or Stop<0:
				return outlist
			elif Start>=Stop:
				return outlist
			#ҵStartֱStopStepΪԪappend
			else:
				pCurrent = self.head
				Cyclecount = 0
				while not pCurrent is None:
					if  count>=Start and count<Stop:
						if Cyclecount%Step==0:
							outlist.append(pCurrent.getData())
						Cyclecount += 1
						count += 1
						pCurrent = pCurrent.getNext()
					elif count>=Stop:
						break
					else:
						count += 1
						pCurrent = pCurrent.getNext()
				return outlist
						
				
	#壺תΪַ
	def __str__(self):
		pCurrent = self.head
		listout = []
		strout = '['
		while pCurrent != None:
			listout.append(pCurrent.getData())
			pCurrent = pCurrent.getNext()
		strout += ','.join(list(map(str, listout)))
		strout += ']'
		return strout
			
#ࣺΪ
class OrderedList(UnorderedList):
	def __init__(self):
		super(OrderedList, self).__init__()
	def add(self, item):
		pPrev = None
		pCurrent = self.head
		while pCurrent!=None and pCurrent.getData()<item:
			pPrev = pCurrent
			pCurrent = pCurrent.getNext()
		newNode = Node(item)
		if pPrev == None:
			newNode.setNext(self.head)
			self.head = newNode
		else:
			newNode.setNext(pCurrent)
			pPrev.setNext(newNode)
	def search(self, item):
		pCurrent = self.head
		count = 0
		while pCurrent!= None:
			if pCurrent.getData()<item:
				pCurrent = pCurrent.getNext()
			elif pCurrent.getData()==item:
				return True
			else:
				return False
		return False
			
"""ΪʵַļٽʽĺײΪƣ˲Ϊ
34ΪӲֵֵ"""
def OperateList(operate, list1, element, index, index1=1):
	if operate=='remove':
		list1.remove(element)
		return 'Done'
	if operate=='getsize':
		return list1.size()
	if operate=='append':
		list1.append(element)
		return 'Done'
	if operate=='search':
		return list1.search(element)
	if operate=='add':
		list1.add(element)
		return 'Done'
	if operate=='index':
		return list1.index(element)
	if operate=='insert':
		return list1.insert(int(index), element)
	if operate=='pop':
		if element==None:
			return list1.pop()
		else:
			return list1.pop(int(element))
	if operate=='getslice':
		if index == None:
			list2 = list1[int(element)]
		else:
			list2 = list1[int(element):int(index):int(index1)]
		print('%s'%(list2,))
		return 'Done'
	if operate=='string':
		return str(list1)

"""¶αΪע͵Ĵڼ		
list3 = OrderedList()
listb = list(map(int, input().split()))
for x in listb:
	list3.add(x)
print('%s'%(list3,))
"""		
"""ΪִвָʽΪ
һʼĶݣ֮ÿһַָ
add+ݣappend+ݣremove+ݣgetsizesearch+
insert++ݣindex+ݣgetslice++βpop+ȱʡ
ÿԪÿոΪУһΪݣڶΪб"""

list1 = UnorderedList()
lista = input().split()
for element in lista:
	list1.append(element)
pCurrent = list1.head
print('%s'%(list1,))
while True:
	try:
		listoperation = input().split()
		index1 = 1
		if len(listoperation)>3:
			opr = listoperation[0]
			#300ˣ
			ele = listoperation[1]
			index = listoperation[2]
			index1 = listoperation[3]
		if len(listoperation)>2:
			opr = listoperation[0]
			ele = listoperation[1]
			index = listoperation[2]
		elif len(listoperation)>1:
			opr = listoperation[0]
			ele = listoperation[1]
			index = None
		else:
			opr = listoperation[0]
			ele = index = None
		print(OperateList(opr, list1, ele, index, index1))
		print('%s'%(list1,))
	except EOFError as e:
		print('End')

#ڴ2017/3/31 ޸ģ2017/4/3

