#*********************************
# Vector类
#By Peizhaowen ,2017.3.7
#*********************************
# -*- coding: utf-8 -*-

class Vector3:
    def __init__(self,x,y,z):
        self.x, self.y, self.z = x, y, z

    def __add__(self, other):
        return Vector3(self.x + other.x,self.y + other.y,self.z + other.z)

    def __sub__(self, other):
        return Vector3(self.x - other.x, self.y - other.y, self.z - other.z)

    def __mul__(self, m):
        return Vector3(self.x * m, self.y * m, self.z * m)

    def __truediv__(self, n):
        return Vector3(self.x / n, self.y / n, self.z / n)

    def __str__(self):
        return '(%s,%s,%s)'% (self.x,self.y,self.z)

data = input().split(' ')
s1, s2, m, n = eval(data[0]), eval(data[1]), int(data[2]), int(data[3])
v1 = Vector3(s1[0], s1[1], s1[2])
v2 = Vector3(s2[0], s2[1], s2[2])
print(str(v1 + v2) + ' ' + str(v1 - v2) + ' ' + str(v1 * m) + ' ' + str(v1 / n))