from unorderedlist import Unorderedlist,UnoderedlistUnderFlowError

class Node:        #鉴于类名重复了很不爽，直接重写一个好了
    def __init__(self, item, pr, ne):
        self.data = item
        self.prev = pr
        self.next = ne
    def setData(self, item):
        self.data = item
    def getData(self):
        return self.data
    def setNext(self, ne):
        self.next = ne
    def getNext(self):
        return self.next
    def setPrev(self, pr):
        self.prev = pr
    def getPrev(self):
        return self.prev

class Deunorderedlist(Unorderedlist):
    def __inti__(self):
        self.tail = self.head = None
    def add(self, item):        #分空的和非空的两种情况添加元素
        if self.head == None:
            self.tail = self.head = Node(item, None, None)
        else:
            temp = Node(item, None, self.head)       #建立一个临时变量，并制定其前后
            self.head.setPrev(temp)
            self.head = temp
    def remove(self, item):                 #在定义了前节点后remove可以做优化，故而改写
        if self.head.getData() == item:
            self.head.getNext().setPrev(None)          #维护结构
            self.head = self.head.getNext()
        else:
            current = self.head
            while current !=None:
                if current.getData() != item:
                    current = current.getNext()
                else:
                    current.getPrev().setNext(current.getNext())    #利用前节点的方法维护结构
                    if current.getNext() != None:
                        current.getNext().setPrev(current.getPrev())
    def append(self, item):
        if self.head == None:
            self.tail = self.head = Node(item, None, None)
        else:
            temp = Node(item, self.tail, None)       #建立一个临时变量，并制定其前后
            self.tail.setNext(temp)
            self.tail = temp
    def pop(self, num = None):
        n = self.size()                     #将长度算出方便计算
        if num == None:
            num = n -1
        if num >= n or self.head == None:           #分为溢出，在开始处pop，结尾处pop，其他情况，其中结尾处pop又分为只有一个元素和多个元素几种情况
            raise UnoderedlistUnderFlowError
        elif num == 0:                              #开始处pop
            temp = self.head.getData()
            self.head.getNext().setPrev(None)
            self.head = self.head.getNext()
            return temp
        elif num == n - 1:                  #末尾处pop，由于双向链表的对称性，只需将开始处的做对偶的修改即可
            temp = self.tail.getData()
            self.tail.getPrev().setNext(None)
            self.tail = self.tail.getPrev()
            return temp
        else:                               #在其他的位置pop
            i = 0
            current = self.head
            while i != num:
                i += 1
                current = current.getNext()
            temp = current.getData()
            current.getPrev().setNext(current.getNext())           #维护前后节点
            current.getNext().setPrev(current.getPrev())
            return temp
