import turtle


def moveTower(height, fromPole, toPole, withPole):                  #关键的汉诺塔递归函数
    if height >= 1:
        moveTower(height - 1, fromPole, withPole, toPole)
        moveDisk(height, fromPole, toPole)
        moveTower(height - 1, withPole, toPole, fromPole)


def moveDisk(height, fp, tp):                                       #移动盘子并维护barlst
    disk[height - 1].goto(-200 + 200 * (ord(fp) - ord("A")), 150)
    disk[height - 1].goto(-200 + 200 * (ord(tp) - ord("A")), 150)
    disk[height - 1].goto(-200 + 200 * (ord(tp) - ord("A")), -100 + 20 * barlst[ord(tp) - ord("A")])
    barlst[ord(fp) - ord("A")] -= 1
    barlst[ord(tp) - ord("A")] += 1


myWin = turtle.Screen()
sumheight = int(input("输入河内塔层数：")                             #输入任意层数，但10层以上会高过我画的柱子
shapelist = [((-10, 20 + 5 * j), (-10, -20 - 5 * j),                  #制作盘子形状
              (10, -20 - 5 * j), (10, 20 + 5 * j)) for j in range(sumheight)]
for k in range(sumheight):
    myWin.register_shape("%d" % k, shapelist[k])
disk = [turtle.Turtle() for x in range(sumheight)]
for i in range(sumheight):                      #生成乌龟改变形状并到达指定位置
    disk[i].up()
    disk[i].goto(-200, -100 + 20 * (sumheight - i - 1))
    disk[i].shape("%d" % i)
myWin.tracer(0)                                 #关闭动画生成柱子
bar = turtle.Turtle()
bar.ht()
bar.pensize(20)
bar.goto(0, 100)
bar.goto(0, -100)
bar.up()
bar.goto(-200, -100)
bar.down()
bar.goto(-200, 100)
bar.up()
bar.goto(200, 100)
bar.down()
bar.goto(200, -100)
myWin.update()
myWin.tracer(1, 10)                             #开启动画，设置时间间隔
barlst = [sumheight, 0, 0]                      #生成每个柱子上的盘数防止盘子移动过程重叠
moveTower(sumheight, "A", "B", "C")             #开始汉诺塔
