import re
class Stack:
    def __init__(self):
        self.items=[]
    def isEmpty(self):
        return self.items==[]
    def push(self,item):
        self.items.append(item)
    def pop(self):
        return self.items.pop()
    def peek(self):
        return self.items[len(self.items)-1]
    def size(self):
        return len(self.items)
    def outlook(self):
        print(self.items)
        # 取字符串中两个符号之间的东东

import sys
htmlstr=sys.stdin.read()
#思路是抓取左右标签存为左右标签列表，则其他处理方法同课件匹配多种括号的
Rlist=sorted((re.findall('</\w*>',htmlstr)))#抓取右标签（一切格式为</字母>的），并排序
Llist=sorted(((re.findall('<\w*>',htmlstr))))#提取左标签（一切格式为<字母>)并存进列表并排序，使左右标签在左右列表里的索引值一一对应
#print(Llist,Rlist)#测试代码用
taglist=(re.findall('<.*?>',htmlstr))#抓取所有tag，用来检查匹配与否
#print(taglist)#测试代码用
def tagChecker(taglist):
    s=Stack()
    balanced=True
    index=0
    while index < len(taglist) and balanced:#如果尚未匹配完且仍然平衡
        tag=taglist[index]#提取之
        if tag in Llist:
            s.push(tag)#如果是左括号，就推进栈
        else:
            if s.isEmpty():
                balanced=False#如果栈是空的却出现了右括号，肯定不平衡
            else:
                top=s.pop()#那么拿出来检查一下是否匹配
                if not matches(top,tag,htmlstr):#matches是匹配检查函数
                    balanced=False
        index=index+1#索引值递进
    if balanced and s.isEmpty():#恰好平衡且栈空了
        return True
    else:
        return False


def matches(open,close,htmlstr):

    Rlist =sorted (re.findall('</.*?>', htmlstr))#右标签存放列表
    Llist = sorted(re.findall('<\w*?>', htmlstr))  # 提取左标签并存进列表
    return Llist.index(open)==Rlist.index(close)#左右的索引一一对应，所以如果索引相等则匹配
print(tagChecker(taglist))



