from unorderedlist import Unorderedlist,Node

class Orderedlist(Unorderedlist):       #只需要修改add方法即可，其余方法均可继承
    def add(self, item):
        if self.head == None:           #链表为空的情况
            self.head = Node(item)
        else:                                   #其余的情况
            temp = Node(item)    #不管怎么样，node总是要创建的
            if item <= self.head.getData():             #比最小的要小的情况
                temp.setNext(self.head)
                self.head  = temp
            else:                                           #其余情况
                pre = self.head
                current = self.head.getNext()
                while current != None:      #循环判断
                    temp1 = pre.getData()
                    temp2 = current.getData()
                    if item <= temp2 and item >= temp1:         #位于中间的情况。由于归纳假设，之前的链表有序，故而可以保证插入后有序
                        temp.setNext(current)
                        pre.setNext(temp)
                        return None                                 #插入完成后直接跳出函数
                    else:                                       #否则继续进行循环
                        pre = current
                        current = current.getNext()
                pre.setNext(temp)       #一直没有结束说明比最大的还要大，直接放在最后面
    def search(self, item):             #由于对于有序链表而言，检索可以通过比较来优化，故而也予以重写
        current = self.head
        while current != None:                     #进行循环
            if current.getData() == item:     #相等则返回True
                return True
            elif current.getData() > item:     #若大于item，则由于之后的元素更大，item不可能在链表内
                return False
            else:
                current = current.getNext()
        return False                            #这个对应于链表为空的情况
