
n = int(input())
width = 10
# 定义两个字符串数字的加法
def add(a,b):
    return str(int(a) + int(b)).center(width)
# 定义一个返回第num行杨辉三角数的字符串构成的列表，采用递归思路
def trianglelist(num):
    # 两个结束条件：num为1
    if num == 1:
        return['1'.center(width), ]
    # 其它情况，减小数据规模
    else:
        # 创建一个储存第n行字符数字的列表，开头插入一个‘1’
        mylist = ['1'.center(width), ]
        # 对于接下来的n-2个字符数字，每一个由第n-1行的对应位置的两个字符数字相加得到
        for i in range(0,num-2):
            mylist.append(add(trianglelist(num-1)[i], trianglelist(num-1)[i+1]))
        # 最后补一个‘1’
        mylist.append('1'.center(width))
        # 返回第n行的字符数字构成的列表
        return mylist
# 利用递归得到前n行的pascal三角的字符串形式
def pascaltriangle(numofrow):
    # 结束条件：若阶数numofrow为1，则返回‘1’，字符总长度100，居中对齐
    if numofrow == 1:
        return '1'.center(200)
    # 否则返回前n行的字符串补'\n'后加上第n行的字符数字列表的字符串形式
    else:
        return pascaltriangle(numofrow-1) + '\n' + ' '.join(trianglelist(numofrow)).center(200)

# 打印最后的pascal三角
print(pascaltriangle(n))
