def nSearch(start,end,alist,num):#不需要切片的函数
    if start<=end:               #递归终止条件，剩最后一个数
        if alist[(start+end)//2]==num:#从中间开始搜寻
            return True
        elif alist[(start+end)//2]>num:#如果偏大向左搜寻
            return nSearch(start,(start+end)//2-1,alist,num)
        else:                          #如果偏小向右搜寻
            return nSearch((start+end)//2+1,end,alist,num)
    else:
        return False             #遍历后没找到

def Search(alist,num):#课件中需要切片的函数
    n=len(alist)
    if n>0:#递归终止条件，列表中有数字
        if alist[n//2-1]==num:#从中间开始
            return True
        elif alist[n//2-1]>num:#如果偏大，将列表切片为左半部分
            return Search(alist[:n//2-1],num)
        else:#如果偏小，切片为右半部分
            return Search(alist[n//2:],num)
    else:#遍历后没找到
        return False

import random
import timeit
alist=[]
#a,b=1,5
#for i in range(1000000):
#    alist.append(random.randint(a,b))
#    a,b=b,b+4
print("请输入需要查找的数字：")
num=int(input())#输入查找的数字
myfunction=timeit.Timer("nSearch(0,n-1,alist,num)","from __main__ import num,nSearch,alist,n")#对不需要切片的函数计时
oldfunction=timeit.Timer("Search(alist,num)","from __main__ import num,alist,Search")#对需要切片的函数的函数计时
print("        myfunction      oldfunction")
for i in range(1000000,10000000,1000000):#生成一个百万级别的列表
    alist=list(range(i))
    n = len(alist)
    mytime=myfunction.timeit(number=1000)
    oldtime=oldfunction.timeit(number=1000)
    print ("%15.5f %15.5f"%(mytime,oldtime))

#以下是部分实验结果
#请输入需要查找的数字：
#       1
#        myfunction      oldfunction
#        0.01387，       16.82330
#        0.01347，       35.56778
#        0.01241，       57.18280
#        0.01359，       76.85209
#        0.01762，      109.68196
#        0.04626，      128.83662
#        0.01614，      151.91768
#        0.04850，      178.68079
#由上，随着列表的增大，不需要切片的函数在时间上的优势越来越明显