source = 'algorithm'
target = 'alligator'

def shortest(s, t):
    a = {}                      #定义一个字典，其中用来存放s字符串前i个字母变换成t字符串前j个的最小编辑距离
    b = {}                   #定义另一个字典用于存放编辑source所用的动作。
    for i in range(len(s) + 1):               #循环，由于递推方程只依赖于较小值，故可以递推而来
        for j in range(len(t) + 1):
            if i == 0:                              #这里i,j=0表示字符串长度为零的情形，即边界条件
                a[(i, j)] = 20 * j
                b[(i, j)] = ['insert'] * j
            elif j == 0:
                a[(i, j)] = 20 * i
                b[(i, j)] = ['del'] * j
            else:
                if s[i - 1] == t[j - 1]:      #分情况讨论并递推，如果最后字符串相等的话可以直接复制，否则不能直接复制，只能添加或删除
                    x = min([(a[(i - 1, j)] + 20, 'i'), (a[(i, j - 1)] + 20, 'd'), (a[(i - 1, j - 1)] + 5, 'c')])        #min函数对于元组列表只比较第一个值并返回元组
                    a[(i, j)] = x[0]
                    if x[1] == 'i':                          #对于不同的情形利用递推关系，分别在b上添加不同的操作
                        b[(i, j)] = b[(i -1, j)] + ['insert']
                    elif x[1] == 'd':
                        b[(i, j)] = b[(i, j -1)] + ['del']
                    else:
                        b[(i, j)] = b[(i - 1, j -1)] + ['copy']
                else:
                    x = min([(a[(i - 1, j)] + 20, 'i'), (a[(i, j - 1)] + 20, 'd')])
                    a[(i, j)] = x[0]
                    if x[1] == 'i':
                        b[(i, j)] = b[(i -1, j)] + ['insert']
                    else:
                        b[(i, j)] = b[(i, j -1)] + ['del']
    return (b[(len(s), len(t))], a[(len(s), len(t))])                   #最后返回我们需要的情况

print(shortest(source, target))                      #将操作作为一个字符串列表，和最小编辑距离打包输出
