def mindist(a, b, scoredict, dodict):   #定义一个得到分数字典和操作字典，key都为元组，操作字典的值为do和letter的列表
    for i in range(-1, len(a)):
        for j in range(-1, len(b)):     #双重迭代遍历所有子序列
            minscore = 20 * (i + j + 2)  #分数初值为最坏情况
            do = None
            if i == -1:                 #如果为边界条件即有一子序列为空
                if j != -1:
                    do = "insert"
            elif j == -1:
                do = "delete"
            else:                       #否则套用动规算法
                if a[i] == b[j]:
                    if scoredict[(i - 1, j - 1)] + 5 <= minscore:
                        minscore = scoredict[(i - 1, j - 1)] + 5
                        do = "copy"
                if scoredict[(i - 1, j)] + 20 <= minscore:
                    minscore = scoredict[(i - 1, j)] + 20
                    do = "delete"
                if scoredict[(i, j - 1)] + 20 <= minscore:
                    minscore = scoredict[(i, j - 1)] + 20
                    do = "insert"
            scoredict[(i, j)] = minscore
            adddodict(a, b, i, j, do, dodict)       #维护分数和操作字典


def adddodict(a, b, i, j, do, dodict):
    if do == "copy":
        dodict[(i, j)] = list(dodict[(i - 1, j - 1)]) + [[do, a[i]]]
    elif do == "delete":
        dodict[(i, j)] = list(dodict[(i - 1, j)]) + [[do, a[i]]]
    elif do == "insert":
        dodict[(i, j)] = list(dodict[(i, j - 1)]) + [[do, b[j]]]
    else:
        dodict[(i, j)] = []
a = input()
b = input()                                 #输入两个字符串
scoredict = {}
dodict = {}
mindist(a, b, scoredict, dodict)
for i in dodict[(len(a) - 1, len(b) - 1)]:
    print(i[0], i[1])                       #依次输出操作
print(scoredict[(len(a) - 1, len(b) - 1)])  #输出最小分数