import timeit
import pylab
timelist1=[]
timelist2=[]
for i in range(10000,1000001,20000):                        #取不同i决定字典规模
    t1=timeit.Timer("x[%d]"%(i-1),"from __main__ import x") #getitem
    t2=timeit.Timer("x[%d]=None"%i,"from __main__ import x")#setitem
    x={j:None for j in range(i)}                            #生成字典
    lst_time1 = t1.timeit(number=100000)                    #测量getitem100000次
    timelist1.append(lst_time1)
    lst_time2 = t2.timeit(number=100000)                    #测量setitem100000次
    timelist2.append(lst_time2)
    print("%d,%10.3f,%10.3f" % (i,lst_time1,lst_time2))     #输出规模和时间
pylab.plot(range(10000,1000001,20000),timelist1,"o")
pylab.plot(range(10000,1000001,20000),timelist2,"o")
pylab.show()                                                #输出时间与规模的关系图
