import timeit
import random
import pylab
timelist1=[]
timelist2=[]
for i in range(10000,1000001,20000):                        #循环生成i增大规模
    s=[]
    while len(s)<1000:
        a=random.randrange(i)
        if a not in s :
            s.append(a)                                     #生成1000个不重复的随机数的列表
    t1=timeit.Timer("del x[0]","from __main__ import x")    #执行del x[0]
    t2=timeit.Timer("""for b in s :
    del x[b]""","from __main__ import x,s")                 #执行删除列表中的key对应item
    x=list(range(i))                                        #生成列表
    lst_time1 = t1.timeit(number=1000)                      #测列表删除时间
    timelist1.append(lst_time1)
    x={j:None for j in range(i)}                            #生成字典
    lst_time2 = t2.timeit(number=1)                         #测字典删除时间
    timelist2.append(lst_time2)
    print("%d,%10.3f,%10.3f" % (i,lst_time1,lst_time2))     #输出规模与时间
pylab.plot(range(10000,1000001,20000),timelist1,"o")
pylab.plot(range(10000,1000001,20000),timelist2,"o")
pylab.show()                                                #输出时间与规模的关系图
