treasure = [{'w':2,'v':3},{'w':3,'v':4},{'w':4,'v':8},{'w':5,'v':8},{'w':9,'v':10}]

def dp(t, weight):
    n = len(t)
    a = {}                           #用a来记录只考虑前i件宝物和负重w的情形下的最大值
    b = {}                    #用b来记录取的是第几个背包
    for i in range(n+1):                #由于只依赖于i,j更小的情形，可以直接从ij的较小值开始循环
        for j in range(weight+1):
            if i ==0 or j == 0:             #这里i,j = 0表示没有宝物和负重，是边界条件
                a[(i, j)] = 0
                b[(i, j)] = []
            else:                         #非边界情形下利用递推关系利用较小值计算较大值。注意如果某个宝物的负重超出了总负重则该项直接记为零。
                x = ( t[i - 1]['v'] + a[(i-1, j - t[i - 1]['w'])] ) if j - t[i - 1]['w'] >= 0 else 0
                y = a[(i-1, j)]
                if x > y:
                    b[(i, j )] = b[(i - 1,  j - t[i - 1]['w'])] + [i - 1]                 #b同样递推地应用前面的列表来生成。其中序号从0开始
                    a[(i, j )] = x
                else:
                    b[i, j] = b[(i - 1, j)]
                    a[(i, j)] = y
    return (b[(n, weight)], a[(n, weight)])               #返回最后我们要的值，把拿的宝物序号放在前面，和最大价值作为一个元组返回

print(dp(treasure, 20))
