import turtle
import random
def tree(branchlen,t,width):
    if  5 < branchlen:                  #最小规模，0直接退出
        t.pensize(width)                #线条宽度为width
        if  branchlen > 80:
            t.color("brown")            #树干颜色为棕色
        else:
            t.color("green")            #树枝颜色为绿色
        t.forward(branchlen)            #画树干
        angle1 = random.randint(20,25)
        t.right(angle1)                 #右倾20~25random度
        tree(branchlen-15,t,width*0.8)  #减小规模，长度减15；树枝宽度减小20%
        if branchlen < 90:              #树枝长度小于90时画叶子和花
            leaf(t, 18, 80.0, "green", 2)
            flower(t, 8, 9, 100.0, "pink", 1.5)
        angle2 = random.randint(40,50)
        t.left(angle2)                  #回左倾40~50random度
        tree(branchlen-15,t,width*0.8)  #减小规模，长度减20；树枝宽度减小20%
        if branchlen < 90:              #后画花芯，防止被挡住
            flower(t, 6, 8, 50.0, "red",1)
        t.right(angle2-angle1)          #回正
        t.penup()                       #返程不画
        t.backward(branchlen)           #海龟回到原位置
        t.pendown()


def petal(t, r, angle):                 #使用turtle画花瓣/叶片，使用半径r和角度两个变量
    for i in range(2):                  #画半径为r，圆周角为angle的弧
        t.circle(r,angle)
        t.left(180-angle)               #向左转180-angle，画花瓣的另一半

def flower(t, n, r, angle,color,size):  #n个花瓣的花
    for i in range(n):
        t.pensize(size)
        t.color(color)
        petal(t, r, angle)
        t.left(360.0/n)

def leaf(t, r, angle,color,size):       #叶子
    t.pensize(size)
    t.color(color)
    petal(t, r, angle)

def main():
    t = turtle.Turtle()
    mywin = turtle.Screen()
    mywin.bgcolor("black")              #背景为黑色
    t.goto(0,-150)
    t.left(90)                          #海龟位置调整
    t.up()
    t.backward(200)
    t.down()
    t.speed(0)                          #海龟加速
    tree(135,t,10)                      #画树
    t.up()
    t.goto(150, -250)
    t.down()
    t.color("yellow")                   #签名
    t.write("©2017 Guanyi Xie. All Rights Reserved.", font=("Times New Roman", 16, "normal"))

    mywin.exitonclick()

main()