import turtle
import random

def tree(branchLen,t):
    if branchLen > 100:                    #树干递归
        t.color("brown")                  #颜色
        t.width(branchLen/10+1)           #粗细与长度相关
        t.forward(branchLen)
        x=random.randrange(20,35)         #随机偏转角度和树干减少长度
        y=random.randrange(30,35)
        t.right(x)
        tree(branchLen-y,t)
        t.left(x*2)
        tree(branchLen-y,t)
        t.right(x)                        #返回初始角度和位置
        t.backward(branchLen)
    elif branchLen > 10:
        t.color("brown")                  #颜色
        t.width(branchLen/10+1)           #粗细与长度相关
        t.forward(branchLen)
        x=random.randrange(20,35)         #随机偏转角度和树干减少长度
        y=random.randrange(15,20)         #枝头减少更短，使树上部更密集逼真
        t.right(x)
        tree(branchLen-y,t)
        t.left(x*2)
        tree(branchLen-y,t)
        t.right(x)                        #返回初始角度和位置
        t.backward(branchLen)
        c=random.randrange(2,3)          #随机长几对树叶
        shouldback=0
        for i in range(0,c):
            Mixleaves(30,t)
            flower(branchLen,t)
            m=random.randrange(20,25)    #树叶之间的枝长短范围内随机
            t.color('brown')
            t.forward(m)
            shouldback+=m               #需要退回去的长度
        t.up()
        t.backward(shouldback)     
        t.down()

def Mixleaves(branchLen,t):             #叶子：复叶
    t.color('green')
    t.width (2)
    t.left(30)
    t.forward(branchLen)                      #复叶的轴
    t.right(45)
    t.circle(8,90)
    t.left(90)
    t.circle(8,90)
    t.left(135)
    t.backward(branchLen)
    i=branchLen/6
    for j in range(6):
        t.forward(i*j)
        leaves(8,t)
        t.backward(i*j)
    t.right(60)
    t.forward(branchLen)                      #复叶的轴
    t.right(45)
    t.circle(8,90)
    t.left(90)
    t.circle(8,90)
    t.left(135)
    t.backward(branchLen)
    for j in range(6):
        t.forward(i*j)
        leaves(8,t)
        t.backward(i*j)
    t.left(30)

def leaves(branchLen,t):
    t.width (2)
    t.circle(branchLen,90)
    t.left(90)
    t.circle(branchLen,90)
    t.circle(branchLen,90)         #复叶上的单叶
    t.left(90)
    t.circle(branchLen,90)
    t.color('green')
    t.left(180)
    
def flower(branchLen,t):           #花，类似合欢花，扇子状
    t.color('pink')
    t.width (1)
    x=10
    for i in range (8): 
        t.forward(10)
        t.backward(10)                              #随机偏转角度
        t.right(x*i)
        t.forward(10)
        t.backward(10)
        t.left(x*i*2)
        t.forward(10)
        t.backward(10)
        t.right(x*i)                        #返回初始角度和位置
        i += 1

        
def main():
    t = turtle.Turtle()                #海龟
    myWin = turtle.Screen()            #屏幕
    turtle.tracer(0)
    t.left(90)
    t.up()
    t.backward(350)
    t.down()                           #调整初始位置
    tree(180,t)
    turtle.update()
    myWin.exitonclick()

main()
        
