def pascalTriangle(numofrow):     #.......生成行数为numofrow的杨辉三角；三角用嵌套元组表示
    if numofrow == 1:                    #..........递归结束条件；返回第一个“三角”（也即 1 ）
        return ((1,),)
    else:             #....................递归式；numofrow行的三角由numofrow - 1行的三角经generateFrom函数变换得到
        return generateFrom(pascalTriangle(numofrow - 1))


def generateFrom(triangle):          #............由最后一行生成新行，传入生成新行之前的三角
    prev = list(triangle[-1])         #............调取最后一行
    num = len(prev) + 1               #............确定新行中数的个数
    prev.insert(0, 0)                 #............prev首尾补零
    prev.append(0)
    new = []                          #............生成新行
    for i in range(num):
        new.append(prev[i] + prev[i+1])
    return triangle + (tuple(new),)      #...........新行转成元组后与传入的三角合并，返回新的三角

numofrow = int(input())
raw = pascalTriangle(numofrow)        #.......生成numofrow行的杨辉三角（嵌套元组），存入raw
base = ' '.join(list(map(str, raw[-1])))     #...........最后一行字符串化
width = len(base)                   #..............获取居中基准宽度
graph = ''
for i in range(len(raw) - 1):          #.........生成字符串化并居中对齐后numofrow - 1行的杨辉三角
    graph += (' '.join(list(map(str, raw[i])))).center(width) + '\n'
print(graph + base)       #............输出numofrow行的杨辉三角图案
