import turtle
import random
def tree(branchlen,branchwide,t):#定义画树函数。
    k1=random.randrange(0,45)
    k2=random.randrange(0,45)
    k3 = random.randrange(0,45)
    k4 = random.randrange(0,45)
    if branchlen > 0:
        t.down()
        if branchlen < 15:               #枝干颜色会随着枝干长度的变化而变化。枝干长度大于50是棕色，15到50是绿色，小于15是粉色
            t.color("pink")
        elif branchlen>50:
            t.color("brown")
        else:
            t.color("green")
        if branchlen < 30:               #当枝干长度小于30时，枝干粗细将变为目前一半，再进行逐步减小。
            branchwide=branchwide/2
        t.pensize(branchwide)
        t.forward(branchlen)
        t.right(k1)                       #每次都将树干长度减10，树枝粗细减0.5
        tree(branchlen-10,branchwide-0.5,t)
        t.right(k2)
        tree(branchlen - 10,branchwide-0.5,t)
        t.left(k1+k2+k3)                  #第一次向左偏转k1,第二次向左偏转k2.之后先向右偏转k1+k2,然后再向右偏转k3.
        tree(branchlen-10,branchwide+0.5,t)
        t.left(k4)                        #向右偏转k4.
        tree(branchlen - 10,branchwide-0.5, t)
        t.right(k3+k4)                    #最后回归中心线。
        t.up()
        t.backward(branchlen)
def main():
    t = turtle.Turtle()
    myWin = turtle.Screen()
    t.up()
    turtle.tracer(0)
    t.goto(10,200)                        #让海龟到（10，200）位置，写下这句诗。
    t.down()
    t.write("不知细叶谁裁出，二月春风似剪刀。",font=("楷体",10,"bold"))#可以规定诗句的字体类型及大小。
    t.up()                                #提起笔，不做图。
    t.goto(0,0)
    t.down()                              #放下笔，开始作图。
    t.left(90)
    t.up()
    t.backward(100)
    t.down()
    tree(70,4,t)
    t.pendown()                            #画完树后，再加粗一下主树干。
    t.color('brown')
    t.pensize(10)
    t.forward(70)
    t.backward(80)
    turtle.update()                        #让海龟暴走。
    myWin.exitonclick()                    #保存画完后的图形。
main()
