#动态规划解决大盗问题
#盗得物品价值最大的函数，参数包括：treasure 宝物列表，maxw 背包容量,maxv 最大价值，flag 某宝物是否被取走
def museumthief(treasure,maxw,maxv,flag):
    alen = len(treasure)                    #算得宝物数量
    for weight in range(maxw+1):            #计算不同背包容量对应的最大价值
        mv = 0                              #初始化最大价值
        for i in range(alen):               #考虑每件宝物是否要偷
           w,v = treasure[i]['w'],treasure[i]['v']      #取得该宝物的重量和价值
           #如果这是第一件宝物，装得下就装
           if i == 0:
               if w<=weight:
                    mv = v
                    flag[weight][i] = True  #这个宝物被装了
               else:
                   mv = 0
           #否则：若背包装得下，进行比较
           else:
               if w <= weight:
                    if maxv[weight - w] + v > mv and maxv[weight - w]+v > maxv[weight - 1] and\
                               flag[weight - w][i] == False:        #如果装了这件宝物价值最大且它没有被装过
                        mv = maxv[weight - w] + v
                        flag[weight] == [False for j in range(alen)]
                        flag[weight][i] = True      #装它
                        for k in range(alen):
                            if flag[weight - w][k] == True:
                                flag[weight][k] = True      #更新flag列表
                    elif maxv[weight - 1] > maxv[weight - w] + v and maxv[weight - 1] > mv:
                        mv = maxv[weight - 1]       #如果不装它价值最大，不装
                        flag[weight] == [False for j in range(alen)]
                        for k in range(alen):
                            if flag[weight - 1][k] == True:
                                flag[weight][k] = True      #更新flag列表
        maxv[weight] = mv       #得到某一背包容量对应的最大价值
    return maxv[maxw]   #返回给定的背包容量对应的最大价值

#输出应该偷哪些宝物的函数
def printOrder(flag,treasure,maxw):
    s=""
    for i in range(len(treasure)):
        if flag[maxw][i] == True:
            s = s+str(i)+' '        #给定的重量的flag列表中，哪件宝物被偷了就输出它
    return s
#给定宝物列表
treasure = [{'w':2,'v':3},{'w':3,'v':4},{'w':4,'v':8},{'w':5,'v':8},{'w':9,'v':10}]
maxw = int(input())     #输入背包重量
maxv = [0] * (maxw+1)   #创建最大价值列表
flag = [[False for i in range(len(treasure))]for j in range(maxw+1)]        #创建是否被取过的flag列表
#输出最大价值与应偷的宝物列表
print("能盗得的最大价值是：",museumthief(treasure,maxw,maxv,flag))
print("你应该偷走这些宝物：",printOrder(flag,treasure,maxw))