from turtle import *
tracer(0)  #设置暴走海龟，让画图更快完成
up()
goto(-500,400)  #让海龟移动到指定的位置，开始作图
down()
x=3       #设置最小单位的长度
def hilbert(i,j):
    if i==1:                      #定义最小的单元：因为每一个单元可以看做是4个节点用三条线连接起来，且四个节点的
        forward(x)                #旋转方向不全相同，当i=1时，j有奇数和偶数两种情况，所以区分出了两个不同旋转方向的
        right(180*j+90)           #最小单元。
        forward(x)
        right(180*j+90)
        forward(x)
    else:
        right(180*j+90)        #当i>1时，是最小节点的扩展，i=1时，最小的节点是一个点，用三条线连起来，有两种不同的方向
        hilbert(i-1,1-j)       #i的值每增加1，上一次的整个结构就变为一个新的节点，
        right(180*j+90)
        forward(x)             #此处为第一个和二个节点之间的连线
        hilbert(i-1,j)         #绘制第二个节点
        left(180*j+90)         #旋转相应的角度
        forward(x)             #第二处连接
        left(180*j+90)
        hilbert(i-1,j)         #第三处节点
        forward(x)             #第三处连接
        right(180*j+90)
        hilbert(i-1,1-j)       #第4个节点
        right(180*j+90)        #调整海龟的方向
hilbert(8,0)                   #阶数为8
update()
exitonclick()