class Map:
    def __init__(self,size):
        self.size = size
        #将容纳单个数据的槽扩展为列表
        self.slots = [ [] for i in range(self.size) ]
        self.data = [ [] for i in range(self.size) ]

    def Mapfunction(self,key):
        return key % self.size

    def put(self,key,data):
        Mapvalue = self.Mapfunction(key)
        #如果key已存在，在对应位置替换数据
        if key in self.slots[Mapvalue]:
            self.data[Mapvalue][self.slots[Mapvalue].index(key)] = data
        #如果不存在，增加之
        else:
            self.slots[Mapvalue].append(key)
            self.data[Mapvalue].append(data)

    def get(self,key):
        #如果找不到key则返回None
        data = None
        position = self.Mapfunction(key)
        if key in self.slots[position]:
            return self.data[position][self.slots[position].index(key)]

    def __delitem__(self, key):
        position = self.Mapfunction(key)
        if key in self.slots[position]:
            #用pop方法删除key和data
            self.slots[position].pop(self.slots[position].index(key))
            self.data[position].pop(self.slots[position].index(key))
        else:
            return "No such key"

    def __len__(self):
        count = 0
        for i in self.slots:
            count = count + len(i)
        return count

    def __getitem__(self,key):
        return self.get(key)

    def __setitem__(self,key,data):
        self.put(key,data)

    def __contains__(self, key):
        position = self.Mapfunction(key)
        if key in self.slots[position]:
            return True
        else:
            return False
