import timeit
import random

for i in range(100000,2000001,100000):
    # 创建Timer对象
    list_del = timeit.Timer("del x[random.randrange(%d)-2000]"%i ,"from __main__ import random ,x")
    dict_del = timeit.Timer("del xdic[random.randrange(%d)]"%i ,"from __main__ import random ,xdic")
    #构建列表及字典
    x = list(range(i))
    xdic = {j: None for j in range(i)}
    # 调用timeit方法，运行1000次
    list_time = list_del.timeit( number = 1000 )
    #防止重复，执行100次
    dict_time = dict_del.timeit( number = 100 )

    print ("%d  %15.5f %15.5f"%(i,list_time,dict_time))